//---------------------------------------------------------
// QA Navigator Suite
// Copyright  2003 - 2007 Ronald D. Grindle
//---------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;

using System.Globalization;

using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Xml;

using QN.Basics;
using QN.DataMiner;

using RG.Basics;
using RG.SQL;
using RG.XMLDB;

namespace QN.Cmpgn {

	/// <summary>
	/// Caution: we're making heavy use of the image indexes to control the logic!
	/// </summary>
	public class frmCmpgnMgr : System.Windows.Forms.Form {

		#region My Members

		private bool m_IsClosed;
		private bool m_IsOpen;
		
		private int m_lstTCSDH, m_lstTCSDW;
		private int m_txtStatDT;
		private int m_comboLogDT;
		private int m_tabc1DH, m_tabc1DW;
		private int m_colDW;

		private int m_TCsAssgn;
		private int m_TotBad;
		private int m_TotDur;
		private int m_TotEx;
		private int m_TotExDur;
		private int m_TotRemExDur;
		private int m_TotTCs;

		private QNDataMiner m_DataMiner;
		private QNGUIservice m_GUIservice;
		private QNphrase m_QNphrase;
		private QNpresets m_Presets;
		private QNTools m_QNTools;

		//list of TCSLstEntries
		private DataLst m_CStatLst;
		private ArrayList m_TCSetLst;

		private static SimpleLog m_Logger;

		private string m_loadUID;

		private string m_uidCmpgn;
		private string m_uidDesc;
		private string m_uidTCSLst;

		private	CmpSelPresets m_CmpSelPresets;
		private TCSelPresets m_TCSSelPresets;

        private RGSQL2 m_DB;

		private XmlDocument m_LoadDoc;
		private XMLDB m_xDB;

		#endregion

		#region Form Members

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuNew;
		private System.Windows.Forms.MenuItem menuOpen;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuSave;
		private System.Windows.Forms.MenuItem menuSaveNew;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.MenuItem menuDel;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.Label lblTitle;
		private System.Windows.Forms.TextBox txtTitle;
		private System.Windows.Forms.Label lblAppl;
		private System.Windows.Forms.ComboBox comboAppl;
		private System.Windows.Forms.TextBox txtOwner;
		private System.Windows.Forms.Label lblOwner;
		private System.Windows.Forms.Label lblSoftRel;
		private System.Windows.Forms.TextBox txtTime;
		private System.Windows.Forms.Label lblTime;
		private System.Windows.Forms.TextBox txtDate;
		private System.Windows.Forms.Label lblDate;
		private System.Windows.Forms.TextBox txtDesc;
		private System.Windows.Forms.Label lblDesc;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.ComboBox comboStat;
		protected System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabTCLst;
		private System.Windows.Forms.TabPage tabStat;
		private System.Windows.Forms.ComboBox comboLog;
		private System.Windows.Forms.TextBox txtStat;
		private System.Windows.Forms.ColumnHeader colHeadTitle;
		private System.Windows.Forms.Label lblTotDur;
		private System.Windows.Forms.TextBox txtTotTCs;
		private System.Windows.Forms.Label lblTotTCs;
		private System.Windows.Forms.TextBox txtTotDur;
		private System.Windows.Forms.ContextMenu ctxtMenuLog;
		private System.Windows.Forms.MenuItem ctxtLogEntry;
		private System.Windows.Forms.ContextMenu ctxtMenuTCSLst;
		private System.Windows.Forms.MenuItem ctxtTCSLstAdd;
		private System.Windows.Forms.MenuItem ctxtTCSLstRem;
		private System.Windows.Forms.MenuItem ctxtTCSLstView;
		private System.Windows.Forms.ColumnHeader colHeadAssgnd;
		private System.Windows.Forms.MenuItem menuRefLst;
		private System.Windows.Forms.ColumnHeader colHeadExpDur;
		private System.Windows.Forms.ColumnHeader colHeadExcTime;
		private System.Windows.Forms.MenuItem ctxtTCSLstViewExec;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuDocu;
		private System.Windows.Forms.MenuItem ctxtTCSLstClear;
		private System.Windows.Forms.TextBox txtTCsAssgn;
		private System.Windows.Forms.Label lblTCsAssgn;
		private System.Windows.Forms.ListView lstvTC;
		private System.Windows.Forms.TextBox txtTCsNotAssgn;
		private System.Windows.Forms.Label lblTCsNotAssgn;
		private System.Windows.Forms.TextBox txtTCsAssgnPc;
		private System.Windows.Forms.Label lblTCsAssgnPc;
		private System.Windows.Forms.TextBox txtTotEx;
		private System.Windows.Forms.Label lblTotEx;
		private System.Windows.Forms.TextBox txtTotNotEx;
		private System.Windows.Forms.Label lblTotNotEx;
		private System.Windows.Forms.TextBox txtTotExDur;
		private System.Windows.Forms.Label lblTotBad;
		private System.Windows.Forms.TextBox txtTotBad;
		private System.Windows.Forms.TextBox txtTotExPc;
		private System.Windows.Forms.Label lblTotExPc;
		private System.Windows.Forms.TextBox txtTotBadPc;
		private System.Windows.Forms.Label lblTotBadPc;
		private System.Windows.Forms.TextBox txtTotRemExDur;
		private System.Windows.Forms.Label lblTotExTime;
		private System.Windows.Forms.Label lblTotRemDur;
		private System.Windows.Forms.MenuItem ctxtTCSLstSep1;
		private System.Windows.Forms.MenuItem ctxtTCSLstSep2;
		private System.Windows.Forms.ColumnHeader colHead1;
		private System.Windows.Forms.ColumnHeader colHead2;
		private System.Windows.Forms.ColumnHeader colHead3;
		private System.Windows.Forms.ImageList imgLstNav;
		private System.Windows.Forms.MenuItem ctxtTCSLstAssgn;
		private System.Windows.Forms.Label lblTotRemDurPc;
		private System.Windows.Forms.TextBox txtTotRemExDurPc;
		private System.Windows.Forms.Label lblExTimeRemFore;
		private System.Windows.Forms.TextBox txtRemExFore;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuPrint;
		private System.Windows.Forms.MenuItem menuUID2Clip;
		private System.Windows.Forms.ComboBox comboSoftRel;
		private System.ComponentModel.IContainer components;
				
		#endregion
		#region Construction/Destruction

		public frmCmpgnMgr() {

			m_Logger = new SimpleLog( "CmpgnMgr" );

			InitializeComponent();

			init();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
                m_DB.close();
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( frmCmpgnMgr ) );
            this.panel1 = new System.Windows.Forms.Panel();
            this.comboSoftRel = new System.Windows.Forms.ComboBox();
            this.lblStatus = new System.Windows.Forms.Label();
            this.comboStat = new System.Windows.Forms.ComboBox();
            this.lblSoftRel = new System.Windows.Forms.Label();
            this.txtTime = new System.Windows.Forms.TextBox();
            this.lblTime = new System.Windows.Forms.Label();
            this.txtDate = new System.Windows.Forms.TextBox();
            this.lblDate = new System.Windows.Forms.Label();
            this.txtDesc = new System.Windows.Forms.TextBox();
            this.lblDesc = new System.Windows.Forms.Label();
            this.txtOwner = new System.Windows.Forms.TextBox();
            this.lblOwner = new System.Windows.Forms.Label();
            this.lblAppl = new System.Windows.Forms.Label();
            this.comboAppl = new System.Windows.Forms.ComboBox();
            this.lblTitle = new System.Windows.Forms.Label();
            this.txtTitle = new System.Windows.Forms.TextBox();
            this.mainMenu = new System.Windows.Forms.MainMenu( this.components );
            this.menuFile = new System.Windows.Forms.MenuItem();
            this.menuNew = new System.Windows.Forms.MenuItem();
            this.menuOpen = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.menuSave = new System.Windows.Forms.MenuItem();
            this.menuSaveNew = new System.Windows.Forms.MenuItem();
            this.menuUID2Clip = new System.Windows.Forms.MenuItem();
            this.menuDel = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.menuRefLst = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.menuPrint = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuExit = new System.Windows.Forms.MenuItem();
            this.menuHelp = new System.Windows.Forms.MenuItem();
            this.menuDocu = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuAbout = new System.Windows.Forms.MenuItem();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabTCLst = new System.Windows.Forms.TabPage();
            this.lstvTC = new System.Windows.Forms.ListView();
            this.colHead1 = new System.Windows.Forms.ColumnHeader();
            this.colHead2 = new System.Windows.Forms.ColumnHeader();
            this.colHead3 = new System.Windows.Forms.ColumnHeader();
            this.colHeadTitle = new System.Windows.Forms.ColumnHeader();
            this.colHeadExpDur = new System.Windows.Forms.ColumnHeader();
            this.colHeadAssgnd = new System.Windows.Forms.ColumnHeader();
            this.colHeadExcTime = new System.Windows.Forms.ColumnHeader();
            this.ctxtMenuTCSLst = new System.Windows.Forms.ContextMenu();
            this.ctxtTCSLstAdd = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstSep1 = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstRem = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstAssgn = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstClear = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstSep2 = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstView = new System.Windows.Forms.MenuItem();
            this.ctxtTCSLstViewExec = new System.Windows.Forms.MenuItem();
            this.imgLstNav = new System.Windows.Forms.ImageList( this.components );
            this.tabStat = new System.Windows.Forms.TabPage();
            this.lblExTimeRemFore = new System.Windows.Forms.Label();
            this.txtRemExFore = new System.Windows.Forms.TextBox();
            this.lblTotRemDurPc = new System.Windows.Forms.Label();
            this.txtTotRemExDurPc = new System.Windows.Forms.TextBox();
            this.lblTotBadPc = new System.Windows.Forms.Label();
            this.lblTotRemDur = new System.Windows.Forms.Label();
            this.lblTotExPc = new System.Windows.Forms.Label();
            this.txtTotBadPc = new System.Windows.Forms.TextBox();
            this.txtTotRemExDur = new System.Windows.Forms.TextBox();
            this.txtTotExPc = new System.Windows.Forms.TextBox();
            this.lblTCsNotAssgn = new System.Windows.Forms.Label();
            this.lblTotEx = new System.Windows.Forms.Label();
            this.lblTotBad = new System.Windows.Forms.Label();
            this.lblTotExTime = new System.Windows.Forms.Label();
            this.lblTotNotEx = new System.Windows.Forms.Label();
            this.lblTCsAssgnPc = new System.Windows.Forms.Label();
            this.txtTotBad = new System.Windows.Forms.TextBox();
            this.txtTotEx = new System.Windows.Forms.TextBox();
            this.txtTotExDur = new System.Windows.Forms.TextBox();
            this.txtTCsAssgnPc = new System.Windows.Forms.TextBox();
            this.txtTotNotEx = new System.Windows.Forms.TextBox();
            this.txtTCsNotAssgn = new System.Windows.Forms.TextBox();
            this.txtTCsAssgn = new System.Windows.Forms.TextBox();
            this.lblTCsAssgn = new System.Windows.Forms.Label();
            this.txtTotDur = new System.Windows.Forms.TextBox();
            this.lblTotDur = new System.Windows.Forms.Label();
            this.txtTotTCs = new System.Windows.Forms.TextBox();
            this.lblTotTCs = new System.Windows.Forms.Label();
            this.comboLog = new System.Windows.Forms.ComboBox();
            this.ctxtMenuLog = new System.Windows.Forms.ContextMenu();
            this.ctxtLogEntry = new System.Windows.Forms.MenuItem();
            this.txtStat = new System.Windows.Forms.TextBox();
            this.panel1.SuspendLayout();
            this.tabControl1.SuspendLayout();
            this.tabTCLst.SuspendLayout();
            this.tabStat.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel1.Controls.Add( this.comboSoftRel );
            this.panel1.Controls.Add( this.lblStatus );
            this.panel1.Controls.Add( this.comboStat );
            this.panel1.Controls.Add( this.lblSoftRel );
            this.panel1.Controls.Add( this.txtTime );
            this.panel1.Controls.Add( this.lblTime );
            this.panel1.Controls.Add( this.txtDate );
            this.panel1.Controls.Add( this.lblDate );
            this.panel1.Controls.Add( this.txtDesc );
            this.panel1.Controls.Add( this.lblDesc );
            this.panel1.Controls.Add( this.txtOwner );
            this.panel1.Controls.Add( this.lblOwner );
            this.panel1.Controls.Add( this.lblAppl );
            this.panel1.Controls.Add( this.comboAppl );
            this.panel1.Controls.Add( this.lblTitle );
            this.panel1.Controls.Add( this.txtTitle );
            this.panel1.Location = new System.Drawing.Point( 5, 5 );
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size( 830, 193 );
            this.panel1.TabIndex = 0;
            // 
            // comboSoftRel
            // 
            this.comboSoftRel.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboSoftRel.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.comboSoftRel.Location = new System.Drawing.Point( 658, 46 );
            this.comboSoftRel.Name = "comboSoftRel";
            this.comboSoftRel.Size = new System.Drawing.Size( 163, 28 );
            this.comboSoftRel.TabIndex = 7;
            // 
            // lblStatus
            // 
            this.lblStatus.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblStatus.Location = new System.Drawing.Point( 562, 83 );
            this.lblStatus.Name = "lblStatus";
            this.lblStatus.Size = new System.Drawing.Size( 96, 25 );
            this.lblStatus.TabIndex = 0;
            this.lblStatus.Text = "Status";
            this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // comboStat
            // 
            this.comboStat.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboStat.Font = new System.Drawing.Font( "Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.comboStat.Location = new System.Drawing.Point( 658, 83 );
            this.comboStat.Name = "comboStat";
            this.comboStat.Size = new System.Drawing.Size( 163, 28 );
            this.comboStat.TabIndex = 5;
            // 
            // lblSoftRel
            // 
            this.lblSoftRel.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblSoftRel.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblSoftRel.Location = new System.Drawing.Point( 562, 46 );
            this.lblSoftRel.Name = "lblSoftRel";
            this.lblSoftRel.Size = new System.Drawing.Size( 96, 26 );
            this.lblSoftRel.TabIndex = 0;
            this.lblSoftRel.Text = "Release";
            this.lblSoftRel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTime
            // 
            this.txtTime.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTime.Location = new System.Drawing.Point( 504, 83 );
            this.txtTime.Name = "txtTime";
            this.txtTime.Size = new System.Drawing.Size( 48, 26 );
            this.txtTime.TabIndex = 0;
            this.txtTime.TabStop = false;
            this.txtTime.Text = "01:59";
            // 
            // lblTime
            // 
            this.lblTime.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTime.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblTime.Location = new System.Drawing.Point( 422, 83 );
            this.lblTime.Name = "lblTime";
            this.lblTime.Size = new System.Drawing.Size( 72, 25 );
            this.lblTime.TabIndex = 0;
            this.lblTime.Text = "Time";
            this.lblTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtDate
            // 
            this.txtDate.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtDate.Location = new System.Drawing.Point( 322, 83 );
            this.txtDate.Name = "txtDate";
            this.txtDate.Size = new System.Drawing.Size( 86, 26 );
            this.txtDate.TabIndex = 0;
            this.txtDate.TabStop = false;
            this.txtDate.Text = "2003-12-31";
            // 
            // lblDate
            // 
            this.lblDate.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblDate.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblDate.Location = new System.Drawing.Point( 245, 83 );
            this.lblDate.Name = "lblDate";
            this.lblDate.Size = new System.Drawing.Size( 72, 25 );
            this.lblDate.TabIndex = 0;
            this.lblDate.Text = "Date";
            this.lblDate.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtDesc
            // 
            this.txtDesc.AcceptsReturn = true;
            this.txtDesc.AcceptsTab = true;
            this.txtDesc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtDesc.Location = new System.Drawing.Point( 115, 119 );
            this.txtDesc.Multiline = true;
            this.txtDesc.Name = "txtDesc";
            this.txtDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.txtDesc.Size = new System.Drawing.Size( 706, 60 );
            this.txtDesc.TabIndex = 6;
            this.txtDesc.Text = "Description";
            this.txtDesc.DoubleClick += new System.EventHandler( this.txtDesc_DoubleClick );
            // 
            // lblDesc
            // 
            this.lblDesc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblDesc.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblDesc.Location = new System.Drawing.Point( 5, 123 );
            this.lblDesc.Name = "lblDesc";
            this.lblDesc.Size = new System.Drawing.Size( 110, 26 );
            this.lblDesc.TabIndex = 0;
            this.lblDesc.Text = "beschreibung";
            this.lblDesc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtOwner
            // 
            this.txtOwner.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtOwner.Location = new System.Drawing.Point( 115, 83 );
            this.txtOwner.Name = "txtOwner";
            this.txtOwner.Size = new System.Drawing.Size( 115, 26 );
            this.txtOwner.TabIndex = 4;
            this.txtOwner.Text = "xxx";
            // 
            // lblOwner
            // 
            this.lblOwner.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblOwner.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblOwner.Location = new System.Drawing.Point( 5, 85 );
            this.lblOwner.Name = "lblOwner";
            this.lblOwner.Size = new System.Drawing.Size( 105, 26 );
            this.lblOwner.TabIndex = 0;
            this.lblOwner.Text = "Owner";
            this.lblOwner.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblAppl
            // 
            this.lblAppl.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F );
            this.lblAppl.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblAppl.Location = new System.Drawing.Point( 5, 47 );
            this.lblAppl.Name = "lblAppl";
            this.lblAppl.Size = new System.Drawing.Size( 110, 26 );
            this.lblAppl.TabIndex = 0;
            this.lblAppl.Text = "Application";
            this.lblAppl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // comboAppl
            // 
            this.comboAppl.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboAppl.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F );
            this.comboAppl.ItemHeight = 20;
            this.comboAppl.Location = new System.Drawing.Point( 115, 45 );
            this.comboAppl.Name = "comboAppl";
            this.comboAppl.Size = new System.Drawing.Size( 437, 28 );
            this.comboAppl.TabIndex = 2;
            // 
            // lblTitle
            // 
            this.lblTitle.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTitle.ImeMode = System.Windows.Forms.ImeMode.NoControl;
            this.lblTitle.Location = new System.Drawing.Point( 5, 9 );
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size( 110, 26 );
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "Title";
            this.lblTitle.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTitle
            // 
            this.txtTitle.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTitle.Location = new System.Drawing.Point( 115, 9 );
            this.txtTitle.Name = "txtTitle";
            this.txtTitle.Size = new System.Drawing.Size( 701, 26 );
            this.txtTitle.TabIndex = 1;
            this.txtTitle.Text = "Title";
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] {
            this.menuFile,
            this.menuHelp} );
            // 
            // menuFile
            // 
            this.menuFile.Index = 0;
            this.menuFile.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] {
            this.menuNew,
            this.menuOpen,
            this.menuItem10,
            this.menuSave,
            this.menuSaveNew,
            this.menuUID2Clip,
            this.menuDel,
            this.menuItem12,
            this.menuRefLst,
            this.menuItem9,
            this.menuPrint,
            this.menuItem1,
            this.menuExit} );
            this.menuFile.Text = "File";
            // 
            // menuNew
            // 
            this.menuNew.Index = 0;
            this.menuNew.Text = "New";
            this.menuNew.Click += new System.EventHandler( this.menuNew_Click );
            // 
            // menuOpen
            // 
            this.menuOpen.Index = 1;
            this.menuOpen.Text = "Open";
            this.menuOpen.Click += new System.EventHandler( this.menuOpen_Click );
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 2;
            this.menuItem10.Text = "-";
            // 
            // menuSave
            // 
            this.menuSave.Index = 3;
            this.menuSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this.menuSave.Text = "Save";
            this.menuSave.Click += new System.EventHandler( this.menuSave_Click );
            // 
            // menuSaveNew
            // 
            this.menuSaveNew.Index = 4;
            this.menuSaveNew.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
            this.menuSaveNew.Text = "Save As New";
            this.menuSaveNew.Click += new System.EventHandler( this.menuSaveNew_Click );
            // 
            // menuUID2Clip
            // 
            this.menuUID2Clip.Index = 5;
            this.menuUID2Clip.Text = "uid 2 clip";
            this.menuUID2Clip.Click += new System.EventHandler( this.menuUID2Clip_Click );
            // 
            // menuDel
            // 
            this.menuDel.Index = 6;
            this.menuDel.Text = "Delete";
            this.menuDel.Click += new System.EventHandler( this.menuDel_Click );
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 7;
            this.menuItem12.Text = "-";
            // 
            // menuRefLst
            // 
            this.menuRefLst.Index = 8;
            this.menuRefLst.Shortcut = System.Windows.Forms.Shortcut.CtrlR;
            this.menuRefLst.Text = "Refresh List";
            this.menuRefLst.Click += new System.EventHandler( this.menuRefLst_Click );
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 9;
            this.menuItem9.Text = "-";
            // 
            // menuPrint
            // 
            this.menuPrint.Index = 10;
            this.menuPrint.Text = "Print";
            this.menuPrint.Click += new System.EventHandler( this.menuPrint_Click );
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 11;
            this.menuItem1.Text = "-";
            // 
            // menuExit
            // 
            this.menuExit.Index = 12;
            this.menuExit.Text = "Exit";
            this.menuExit.Click += new System.EventHandler( this.menuExit_Click );
            // 
            // menuHelp
            // 
            this.menuHelp.Index = 1;
            this.menuHelp.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] {
            this.menuDocu,
            this.menuItem3,
            this.menuAbout} );
            this.menuHelp.Text = "Help";
            // 
            // menuDocu
            // 
            this.menuDocu.Index = 0;
            this.menuDocu.Text = "Docu";
            this.menuDocu.Click += new System.EventHandler( this.menuDocu_Click );
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 1;
            this.menuItem3.Text = "-";
            // 
            // menuAbout
            // 
            this.menuAbout.Index = 2;
            this.menuAbout.Text = "About";
            this.menuAbout.Click += new System.EventHandler( this.menuAbout_Click );
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add( this.tabTCLst );
            this.tabControl1.Controls.Add( this.tabStat );
            this.tabControl1.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.tabControl1.Location = new System.Drawing.Point( 5, 203 );
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size( 830, 346 );
            this.tabControl1.TabIndex = 7;
            // 
            // tabTCLst
            // 
            this.tabTCLst.Controls.Add( this.lstvTC );
            this.tabTCLst.Location = new System.Drawing.Point( 4, 29 );
            this.tabTCLst.Name = "tabTCLst";
            this.tabTCLst.Size = new System.Drawing.Size( 822, 313 );
            this.tabTCLst.TabIndex = 0;
            this.tabTCLst.Text = "TC Lst";
            // 
            // lstvTC
            // 
            this.lstvTC.Columns.AddRange( new System.Windows.Forms.ColumnHeader[] {
            this.colHead1,
            this.colHead2,
            this.colHead3,
            this.colHeadTitle,
            this.colHeadExpDur,
            this.colHeadAssgnd,
            this.colHeadExcTime} );
            this.lstvTC.ContextMenu = this.ctxtMenuTCSLst;
            this.lstvTC.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lstvTC.FullRowSelect = true;
            this.lstvTC.GridLines = true;
            this.lstvTC.Location = new System.Drawing.Point( 5, 5 );
            this.lstvTC.Name = "lstvTC";
            this.lstvTC.Size = new System.Drawing.Size( 811, 304 );
            this.lstvTC.SmallImageList = this.imgLstNav;
            this.lstvTC.TabIndex = 8;
            this.lstvTC.UseCompatibleStateImageBehavior = false;
            this.lstvTC.View = System.Windows.Forms.View.Details;
            this.lstvTC.DoubleClick += new System.EventHandler( this.lstvTC_DoubleClick );
            // 
            // colHead1
            // 
            this.colHead1.Text = "";
            this.colHead1.Width = 40;
            // 
            // colHead2
            // 
            this.colHead2.Text = "";
            this.colHead2.Width = 10;
            // 
            // colHead3
            // 
            this.colHead3.Text = "";
            this.colHead3.Width = 10;
            // 
            // colHeadTitle
            // 
            this.colHeadTitle.Text = "title";
            this.colHeadTitle.Width = 384;
            // 
            // colHeadExpDur
            // 
            this.colHeadExpDur.Text = "duration";
            this.colHeadExpDur.Width = 65;
            // 
            // colHeadAssgnd
            // 
            this.colHeadAssgnd.Text = "Zugeordnet";
            this.colHeadAssgnd.Width = 82;
            // 
            // colHeadExcTime
            // 
            this.colHeadExcTime.Text = "a-zeit";
            // 
            // ctxtMenuTCSLst
            // 
            this.ctxtMenuTCSLst.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] {
            this.ctxtTCSLstAdd,
            this.ctxtTCSLstSep1,
            this.ctxtTCSLstRem,
            this.ctxtTCSLstAssgn,
            this.ctxtTCSLstClear,
            this.ctxtTCSLstSep2,
            this.ctxtTCSLstView,
            this.ctxtTCSLstViewExec} );
            this.ctxtMenuTCSLst.Popup += new System.EventHandler( this.ctxtMenuTCSLst_Popup );
            // 
            // ctxtTCSLstAdd
            // 
            this.ctxtTCSLstAdd.Index = 0;
            this.ctxtTCSLstAdd.Text = "add TC set";
            this.ctxtTCSLstAdd.Click += new System.EventHandler( this.ctxtTCSLstAdd_Click );
            // 
            // ctxtTCSLstSep1
            // 
            this.ctxtTCSLstSep1.Index = 1;
            this.ctxtTCSLstSep1.Text = "-";
            // 
            // ctxtTCSLstRem
            // 
            this.ctxtTCSLstRem.Index = 2;
            this.ctxtTCSLstRem.Text = "remove";
            this.ctxtTCSLstRem.Click += new System.EventHandler( this.ctxtTCSLstRem_Click );
            // 
            // ctxtTCSLstAssgn
            // 
            this.ctxtTCSLstAssgn.Index = 3;
            this.ctxtTCSLstAssgn.Text = "assign";
            this.ctxtTCSLstAssgn.Click += new System.EventHandler( this.ctxtTCSLstAssgn_Click );
            // 
            // ctxtTCSLstClear
            // 
            this.ctxtTCSLstClear.Index = 4;
            this.ctxtTCSLstClear.Text = "clear assignment";
            this.ctxtTCSLstClear.Click += new System.EventHandler( this.ctxtTCSLstClear_Click );
            // 
            // ctxtTCSLstSep2
            // 
            this.ctxtTCSLstSep2.Index = 5;
            this.ctxtTCSLstSep2.Text = "-";
            // 
            // ctxtTCSLstView
            // 
            this.ctxtTCSLstView.Index = 6;
            this.ctxtTCSLstView.Text = "view";
            this.ctxtTCSLstView.Click += new System.EventHandler( this.ctxtTCSLstView_Click );
            // 
            // ctxtTCSLstViewExec
            // 
            this.ctxtTCSLstViewExec.Index = 7;
            this.ctxtTCSLstViewExec.Text = "view Exec";
            this.ctxtTCSLstViewExec.Click += new System.EventHandler( this.ctxtTCSLstViewExec_Click );
            // 
            // imgLstNav
            // 
            this.imgLstNav.ImageStream = ( (System.Windows.Forms.ImageListStreamer)( resources.GetObject( "imgLstNav.ImageStream" ) ) );
            this.imgLstNav.TransparentColor = System.Drawing.Color.Transparent;
            this.imgLstNav.Images.SetKeyName( 0, "" );
            this.imgLstNav.Images.SetKeyName( 1, "" );
            this.imgLstNav.Images.SetKeyName( 2, "" );
            this.imgLstNav.Images.SetKeyName( 3, "" );
            this.imgLstNav.Images.SetKeyName( 4, "" );
            this.imgLstNav.Images.SetKeyName( 5, "" );
            // 
            // tabStat
            // 
            this.tabStat.Controls.Add( this.lblExTimeRemFore );
            this.tabStat.Controls.Add( this.txtRemExFore );
            this.tabStat.Controls.Add( this.lblTotRemDurPc );
            this.tabStat.Controls.Add( this.txtTotRemExDurPc );
            this.tabStat.Controls.Add( this.lblTotBadPc );
            this.tabStat.Controls.Add( this.lblTotRemDur );
            this.tabStat.Controls.Add( this.lblTotExPc );
            this.tabStat.Controls.Add( this.txtTotBadPc );
            this.tabStat.Controls.Add( this.txtTotRemExDur );
            this.tabStat.Controls.Add( this.txtTotExPc );
            this.tabStat.Controls.Add( this.lblTCsNotAssgn );
            this.tabStat.Controls.Add( this.lblTotEx );
            this.tabStat.Controls.Add( this.lblTotBad );
            this.tabStat.Controls.Add( this.lblTotExTime );
            this.tabStat.Controls.Add( this.lblTotNotEx );
            this.tabStat.Controls.Add( this.lblTCsAssgnPc );
            this.tabStat.Controls.Add( this.txtTotBad );
            this.tabStat.Controls.Add( this.txtTotEx );
            this.tabStat.Controls.Add( this.txtTotExDur );
            this.tabStat.Controls.Add( this.txtTCsAssgnPc );
            this.tabStat.Controls.Add( this.txtTotNotEx );
            this.tabStat.Controls.Add( this.txtTCsNotAssgn );
            this.tabStat.Controls.Add( this.txtTCsAssgn );
            this.tabStat.Controls.Add( this.lblTCsAssgn );
            this.tabStat.Controls.Add( this.txtTotDur );
            this.tabStat.Controls.Add( this.lblTotDur );
            this.tabStat.Controls.Add( this.txtTotTCs );
            this.tabStat.Controls.Add( this.lblTotTCs );
            this.tabStat.Location = new System.Drawing.Point( 4, 29 );
            this.tabStat.Name = "tabStat";
            this.tabStat.Size = new System.Drawing.Size( 822, 313 );
            this.tabStat.TabIndex = 1;
            this.tabStat.Text = "Stat";
            // 
            // lblExTimeRemFore
            // 
            this.lblExTimeRemFore.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblExTimeRemFore.Location = new System.Drawing.Point( 235, 240 );
            this.lblExTimeRemFore.Name = "lblExTimeRemFore";
            this.lblExTimeRemFore.Size = new System.Drawing.Size( 192, 37 );
            this.lblExTimeRemFore.TabIndex = 41;
            this.lblExTimeRemFore.Text = "execution time remaining (forecast)";
            this.lblExTimeRemFore.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtRemExFore
            // 
            this.txtRemExFore.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtRemExFore.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtRemExFore.Location = new System.Drawing.Point( 437, 240 );
            this.txtRemExFore.Name = "txtRemExFore";
            this.txtRemExFore.ReadOnly = true;
            this.txtRemExFore.Size = new System.Drawing.Size( 62, 26 );
            this.txtRemExFore.TabIndex = 40;
            this.txtRemExFore.TabStop = false;
            this.txtRemExFore.Text = "99999";
            // 
            // lblTotRemDurPc
            // 
            this.lblTotRemDurPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotRemDurPc.Location = new System.Drawing.Point( 528, 194 );
            this.lblTotRemDurPc.Name = "lblTotRemDurPc";
            this.lblTotRemDurPc.Size = new System.Drawing.Size( 178, 41 );
            this.lblTotRemDurPc.TabIndex = 39;
            this.lblTotRemDurPc.Text = "total duration remaining (%)";
            this.lblTotRemDurPc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTotRemExDurPc
            // 
            this.txtTotRemExDurPc.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotRemExDurPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotRemExDurPc.Location = new System.Drawing.Point( 725, 194 );
            this.txtTotRemExDurPc.Name = "txtTotRemExDurPc";
            this.txtTotRemExDurPc.ReadOnly = true;
            this.txtTotRemExDurPc.Size = new System.Drawing.Size( 62, 26 );
            this.txtTotRemExDurPc.TabIndex = 38;
            this.txtTotRemExDurPc.TabStop = false;
            this.txtTotRemExDurPc.Text = "99999";
            // 
            // lblTotBadPc
            // 
            this.lblTotBadPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotBadPc.Location = new System.Drawing.Point( 240, 148 );
            this.lblTotBadPc.Name = "lblTotBadPc";
            this.lblTotBadPc.Size = new System.Drawing.Size( 187, 23 );
            this.lblTotBadPc.TabIndex = 37;
            this.lblTotBadPc.Text = "total TCs in Error (%)";
            this.lblTotBadPc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotRemDur
            // 
            this.lblTotRemDur.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotRemDur.Location = new System.Drawing.Point( 235, 194 );
            this.lblTotRemDur.Name = "lblTotRemDur";
            this.lblTotRemDur.Size = new System.Drawing.Size( 192, 41 );
            this.lblTotRemDur.TabIndex = 36;
            this.lblTotRemDur.Text = "total duration remaining (est.)";
            this.lblTotRemDur.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotExPc
            // 
            this.lblTotExPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotExPc.Location = new System.Drawing.Point( 528, 97 );
            this.lblTotExPc.Name = "lblTotExPc";
            this.lblTotExPc.Size = new System.Drawing.Size( 178, 23 );
            this.lblTotExPc.TabIndex = 35;
            this.lblTotExPc.Text = "total TCs executed (%)";
            this.lblTotExPc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTotBadPc
            // 
            this.txtTotBadPc.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotBadPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotBadPc.Location = new System.Drawing.Point( 437, 148 );
            this.txtTotBadPc.Name = "txtTotBadPc";
            this.txtTotBadPc.ReadOnly = true;
            this.txtTotBadPc.Size = new System.Drawing.Size( 62, 26 );
            this.txtTotBadPc.TabIndex = 18;
            this.txtTotBadPc.TabStop = false;
            this.txtTotBadPc.Text = "99999";
            // 
            // txtTotRemExDur
            // 
            this.txtTotRemExDur.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotRemExDur.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotRemExDur.Location = new System.Drawing.Point( 437, 194 );
            this.txtTotRemExDur.Name = "txtTotRemExDur";
            this.txtTotRemExDur.ReadOnly = true;
            this.txtTotRemExDur.Size = new System.Drawing.Size( 62, 26 );
            this.txtTotRemExDur.TabIndex = 21;
            this.txtTotRemExDur.TabStop = false;
            this.txtTotRemExDur.Text = "99999";
            // 
            // txtTotExPc
            // 
            this.txtTotExPc.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotExPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotExPc.Location = new System.Drawing.Point( 725, 97 );
            this.txtTotExPc.Name = "txtTotExPc";
            this.txtTotExPc.ReadOnly = true;
            this.txtTotExPc.Size = new System.Drawing.Size( 62, 26 );
            this.txtTotExPc.TabIndex = 16;
            this.txtTotExPc.TabStop = false;
            this.txtTotExPc.Text = "99999";
            // 
            // lblTCsNotAssgn
            // 
            this.lblTCsNotAssgn.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTCsNotAssgn.Location = new System.Drawing.Point( 240, 51 );
            this.lblTCsNotAssgn.Name = "lblTCsNotAssgn";
            this.lblTCsNotAssgn.Size = new System.Drawing.Size( 187, 23 );
            this.lblTCsNotAssgn.TabIndex = 30;
            this.lblTCsNotAssgn.Text = "TCs not assigned";
            this.lblTCsNotAssgn.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotEx
            // 
            this.lblTotEx.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotEx.Location = new System.Drawing.Point( 10, 97 );
            this.lblTotEx.Name = "lblTotEx";
            this.lblTotEx.Size = new System.Drawing.Size( 139, 23 );
            this.lblTotEx.TabIndex = 29;
            this.lblTotEx.Text = "TCs executed";
            this.lblTotEx.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotBad
            // 
            this.lblTotBad.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotBad.Location = new System.Drawing.Point( 10, 148 );
            this.lblTotBad.Name = "lblTotBad";
            this.lblTotBad.Size = new System.Drawing.Size( 139, 23 );
            this.lblTotBad.TabIndex = 28;
            this.lblTotBad.Text = "total TCs in Error";
            this.lblTotBad.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotExTime
            // 
            this.lblTotExTime.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotExTime.Location = new System.Drawing.Point( 5, 240 );
            this.lblTotExTime.Name = "lblTotExTime";
            this.lblTotExTime.Size = new System.Drawing.Size( 144, 37 );
            this.lblTotExTime.TabIndex = 27;
            this.lblTotExTime.Text = "execution time of executed TCs";
            this.lblTotExTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTotNotEx
            // 
            this.lblTotNotEx.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotNotEx.Location = new System.Drawing.Point( 240, 97 );
            this.lblTotNotEx.Name = "lblTotNotEx";
            this.lblTotNotEx.Size = new System.Drawing.Size( 187, 23 );
            this.lblTotNotEx.TabIndex = 26;
            this.lblTotNotEx.Text = "TCs not executed";
            this.lblTotNotEx.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblTCsAssgnPc
            // 
            this.lblTCsAssgnPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTCsAssgnPc.Location = new System.Drawing.Point( 528, 51 );
            this.lblTCsAssgnPc.Name = "lblTCsAssgnPc";
            this.lblTCsAssgnPc.Size = new System.Drawing.Size( 178, 23 );
            this.lblTCsAssgnPc.TabIndex = 25;
            this.lblTCsAssgnPc.Text = "TCs Assigned (%)";
            this.lblTCsAssgnPc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTotBad
            // 
            this.txtTotBad.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotBad.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotBad.Location = new System.Drawing.Point( 158, 148 );
            this.txtTotBad.Name = "txtTotBad";
            this.txtTotBad.ReadOnly = true;
            this.txtTotBad.Size = new System.Drawing.Size( 63, 26 );
            this.txtTotBad.TabIndex = 17;
            this.txtTotBad.TabStop = false;
            this.txtTotBad.Text = "99999";
            // 
            // txtTotEx
            // 
            this.txtTotEx.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotEx.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotEx.Location = new System.Drawing.Point( 158, 97 );
            this.txtTotEx.Name = "txtTotEx";
            this.txtTotEx.ReadOnly = true;
            this.txtTotEx.Size = new System.Drawing.Size( 63, 26 );
            this.txtTotEx.TabIndex = 14;
            this.txtTotEx.TabStop = false;
            this.txtTotEx.Text = "99999";
            // 
            // txtTotExDur
            // 
            this.txtTotExDur.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotExDur.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotExDur.Location = new System.Drawing.Point( 158, 240 );
            this.txtTotExDur.Name = "txtTotExDur";
            this.txtTotExDur.ReadOnly = true;
            this.txtTotExDur.Size = new System.Drawing.Size( 63, 26 );
            this.txtTotExDur.TabIndex = 22;
            this.txtTotExDur.TabStop = false;
            this.txtTotExDur.Text = "99999";
            // 
            // txtTCsAssgnPc
            // 
            this.txtTCsAssgnPc.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTCsAssgnPc.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTCsAssgnPc.Location = new System.Drawing.Point( 725, 51 );
            this.txtTCsAssgnPc.Name = "txtTCsAssgnPc";
            this.txtTCsAssgnPc.ReadOnly = true;
            this.txtTCsAssgnPc.Size = new System.Drawing.Size( 62, 26 );
            this.txtTCsAssgnPc.TabIndex = 13;
            this.txtTCsAssgnPc.TabStop = false;
            this.txtTCsAssgnPc.Text = "99999";
            // 
            // txtTotNotEx
            // 
            this.txtTotNotEx.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotNotEx.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotNotEx.Location = new System.Drawing.Point( 437, 97 );
            this.txtTotNotEx.Name = "txtTotNotEx";
            this.txtTotNotEx.ReadOnly = true;
            this.txtTotNotEx.Size = new System.Drawing.Size( 62, 26 );
            this.txtTotNotEx.TabIndex = 15;
            this.txtTotNotEx.TabStop = false;
            this.txtTotNotEx.Text = "99999";
            // 
            // txtTCsNotAssgn
            // 
            this.txtTCsNotAssgn.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTCsNotAssgn.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTCsNotAssgn.Location = new System.Drawing.Point( 437, 51 );
            this.txtTCsNotAssgn.Name = "txtTCsNotAssgn";
            this.txtTCsNotAssgn.ReadOnly = true;
            this.txtTCsNotAssgn.Size = new System.Drawing.Size( 62, 26 );
            this.txtTCsNotAssgn.TabIndex = 12;
            this.txtTCsNotAssgn.TabStop = false;
            this.txtTCsNotAssgn.Text = "99999";
            // 
            // txtTCsAssgn
            // 
            this.txtTCsAssgn.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTCsAssgn.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTCsAssgn.Location = new System.Drawing.Point( 158, 51 );
            this.txtTCsAssgn.Name = "txtTCsAssgn";
            this.txtTCsAssgn.ReadOnly = true;
            this.txtTCsAssgn.Size = new System.Drawing.Size( 63, 26 );
            this.txtTCsAssgn.TabIndex = 11;
            this.txtTCsAssgn.TabStop = false;
            this.txtTCsAssgn.Text = "99999";
            // 
            // lblTCsAssgn
            // 
            this.lblTCsAssgn.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTCsAssgn.Location = new System.Drawing.Point( 10, 51 );
            this.lblTCsAssgn.Name = "lblTCsAssgn";
            this.lblTCsAssgn.Size = new System.Drawing.Size( 139, 23 );
            this.lblTCsAssgn.TabIndex = 18;
            this.lblTCsAssgn.Text = "TCs assigned";
            this.lblTCsAssgn.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTotDur
            // 
            this.txtTotDur.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotDur.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotDur.Location = new System.Drawing.Point( 158, 194 );
            this.txtTotDur.Name = "txtTotDur";
            this.txtTotDur.Size = new System.Drawing.Size( 63, 26 );
            this.txtTotDur.TabIndex = 20;
            this.txtTotDur.TabStop = false;
            this.txtTotDur.Text = "999";
            // 
            // lblTotDur
            // 
            this.lblTotDur.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotDur.Location = new System.Drawing.Point( 5, 194 );
            this.lblTotDur.Name = "lblTotDur";
            this.lblTotDur.Size = new System.Drawing.Size( 139, 23 );
            this.lblTotDur.TabIndex = 16;
            this.lblTotDur.Text = "Total est. duration";
            this.lblTotDur.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtTotTCs
            // 
            this.txtTotTCs.BackColor = System.Drawing.Color.LightSteelBlue;
            this.txtTotTCs.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtTotTCs.Location = new System.Drawing.Point( 158, 9 );
            this.txtTotTCs.Name = "txtTotTCs";
            this.txtTotTCs.ReadOnly = true;
            this.txtTotTCs.Size = new System.Drawing.Size( 63, 26 );
            this.txtTotTCs.TabIndex = 10;
            this.txtTotTCs.TabStop = false;
            this.txtTotTCs.Text = "99999";
            // 
            // lblTotTCs
            // 
            this.lblTotTCs.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.lblTotTCs.Location = new System.Drawing.Point( 10, 9 );
            this.lblTotTCs.Name = "lblTotTCs";
            this.lblTotTCs.Size = new System.Drawing.Size( 139, 23 );
            this.lblTotTCs.TabIndex = 14;
            this.lblTotTCs.Text = "TCs";
            this.lblTotTCs.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // comboLog
            // 
            this.comboLog.ContextMenu = this.ctxtMenuLog;
            this.comboLog.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboLog.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.comboLog.ItemHeight = 20;
            this.comboLog.Location = new System.Drawing.Point( 149, 558 );
            this.comboLog.Name = "comboLog";
            this.comboLog.Size = new System.Drawing.Size( 686, 28 );
            this.comboLog.TabIndex = 9;
            // 
            // ctxtMenuLog
            // 
            this.ctxtMenuLog.MenuItems.AddRange( new System.Windows.Forms.MenuItem[] {
            this.ctxtLogEntry} );
            // 
            // ctxtLogEntry
            // 
            this.ctxtLogEntry.Index = 0;
            this.ctxtLogEntry.Text = "Display Entry";
            this.ctxtLogEntry.Click += new System.EventHandler( this.ctxtLogEntry_Click );
            // 
            // txtStat
            // 
            this.txtStat.BackColor = System.Drawing.Color.Yellow;
            this.txtStat.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtStat.Location = new System.Drawing.Point( 10, 558 );
            this.txtStat.Name = "txtStat";
            this.txtStat.ReadOnly = true;
            this.txtStat.Size = new System.Drawing.Size( 129, 26 );
            this.txtStat.TabIndex = 0;
            this.txtStat.TabStop = false;
            this.txtStat.Text = "Initializing...";
            this.txtStat.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // frmCmpgnMgr
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 6, 15 );
            this.ClientSize = new System.Drawing.Size( 856, 629 );
            this.Controls.Add( this.comboLog );
            this.Controls.Add( this.txtStat );
            this.Controls.Add( this.tabControl1 );
            this.Controls.Add( this.panel1 );
            this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
            this.Menu = this.mainMenu;
            this.MinimumSize = new System.Drawing.Size( 864, 669 );
            this.Name = "frmCmpgnMgr";
            this.Text = "Campaign";
            this.Resize += new System.EventHandler( this.frmCmpgnMgr_Resize );
            this.panel1.ResumeLayout( false );
            this.panel1.PerformLayout();
            this.tabControl1.ResumeLayout( false );
            this.tabTCLst.ResumeLayout( false );
            this.tabStat.ResumeLayout( false );
            this.tabStat.PerformLayout();
            this.ResumeLayout( false );
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new frmCmpgnMgr());
		}

		#region My Stuff

		//-------------------------------------------------------------------------					
		private void addLog( IRslt p_Res ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Res.getRsltLastMsg();

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( ref p_Res );

			comboLog.SelectedIndex = ix;
		}

		//-------------------------------------------------------------------------					
		private void addLog( string p_Msg ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Msg;

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( msg );

			comboLog.SelectedIndex = ix;
		}

		//---------------------------------
		private void addTCStoLst( ref DatLstEntry p_Entry ) {		

			int ix;
			int dur, ttcs;

			string expDur;
			string totTCs;

			QNTCSetLst tcSet;
			RsltLst tcLst;

			try {
				
				TCSLstEntry tcsEntry = new TCSLstEntry();

				tcsEntry.m_RefUID = p_Entry.val;
				tcsEntry.m_Title = p_Entry.label;

				expDur = m_xDB.getAttrVal( p_Entry.val, "ExpDur" );
				tcsEntry.m_ExpDur = expDur;

				totTCs = m_xDB.getAttrVal( p_Entry.val, "TotTCs" );

				// TC list
				tcSet = new QNTCSetLst( m_xDB, p_Entry.val );

				tcLst = tcSet.getTCLst();

				tcsEntry.m_TCLst = tcLst;

				ix = m_TCSetLst.Count;
	
				m_TCSetLst.Add( tcsEntry );

				int[] idxLst = new int[3];

				idxLst[0] = ix;
				idxLst[1] = -1;
				idxLst[2] = -1;

				// List View
				ListViewItem lvi;

				// LstOper, Title, Duration, Assignee, X-Time
				lvi = new ListViewItem();
				lvi.ImageIndex = 0;
				lvi.SubItems.Add( "" );
				lvi.SubItems.Add( "" );
				lvi.SubItems.Add( p_Entry.label );
				lvi.SubItems.Add( expDur );
				lvi.SubItems.Add( "" );
				lvi.SubItems.Add( "" );
				lvi.Tag = new TCLstTag( true, 0, idxLst );

				if( totTCs.Length > 0 ) {

					ttcs = Convert.ToInt32( totTCs );

					m_TotTCs += ttcs;
				}

				if( expDur.Length > 0 ) {

					dur = Convert.ToInt32( expDur );

					m_TotDur += dur;

					m_TotRemExDur += dur;
				}

				lstvTC.Items.Add( lvi );
			}
			catch( Exception excp ) {
				
				handleExcp( excp );
			}	
		}

		// ---------------------------------
		private void appTCSLstSub( RsltXMLNode p_TCSListNode, TCSLstEntry p_TCSLstEnt ) {
		
			int i, j, x, y;

			ArrayList aTCLst;
  
			RsltXMLNode tcNode;
			RsltXMLNode tcSetNode;

			SetList aTCExUIDLst;

			string aUID;

			TCLstEntry aTCLstEnt;
			TCLstEntBase someTCLstEnt;
			TCSLstEntry	aTCSLstEnt;

			XMLDBNode aTCExDBNode;
			
			XmlNode xNode;

			/*
			<!ELEMENT CmpgnTCSet (CmpgnTCSet, RefCTC*)>
				<!ATTLIST CmpgnTCSet
					Assignd			CDATA #IMPLIED
					ExpDur	NMTOKEN #IMPLIED
					RefUID	NMTOKEN #REQUIRED
					Title		CDATA #REQUIRED
					UID			NMTOKEN #IMPLIED
				>
			*/

			tcSetNode = p_TCSListNode.appNode( "CmpgnTCSet" );

			tcSetNode.addAttribAsHtml( "Assignd", p_TCSLstEnt.m_Assgn );
			tcSetNode.addAttrib( "ExpDur", p_TCSLstEnt.m_ExpDur );
			tcSetNode.addAttrib( "RefUID", p_TCSLstEnt.m_RefUID );
			tcSetNode.addAttribAsHtml( "Title", p_TCSLstEnt.m_Title );
			tcSetNode.addUID( p_TCSLstEnt.m_UID );

			aTCLst = p_TCSLstEnt.m_TCLst;

			x = aTCLst.Count;

			for( i = 0; i < x; ++i ) {

				someTCLstEnt = (TCLstEntBase)aTCLst[i];
				
				if( someTCLstEnt.m_isSet ) {

					aTCSLstEnt = (TCSLstEntry)aTCLst[i];

					appTCSLstSub( tcSetNode, aTCSLstEnt );
				}
				else {

					aTCLstEnt = (TCLstEntry)aTCLst[i];

					/*
					<!ELEMENT RefCTC (RefTCExec*)>
						<!ATTLIST RefCTC
							Assignd			CDATA #IMPLIED
							ExpDur			NMTOKEN #IMPLIED
							RefUID			NMTOKEN #REQUIRED
							Title				CDATA #REQUIRED
							UID					NMTOKEN #IMPLIED
						>
					*/ 

					tcNode = tcSetNode.appNode( "RefCTC" );

					tcNode.addAttribAsHtml( "Assignd", aTCLstEnt.m_Assgn );
					tcNode.addAttrib( "ExpDur", aTCLstEnt.m_ExpDur );
					tcNode.addAttrib( "RefUID", aTCLstEnt.m_RefUID );
					tcNode.addAttribAsHtml( "Title", aTCLstEnt.m_Title );
					tcNode.addUID( aTCLstEnt.m_UID );

					//Instead of using the stored list of executions we load the list from the DB
					//as they may have changed in the mean time.
					aTCExUIDLst = m_xDB.getUIDLstByParent( "RefTCExec", aTCLstEnt.m_UID );

					y = aTCExUIDLst.Count;

					for( j = 0; j < y; ++j ) { 

						/*
							<!ELEMENT RefTCExec (EMPTY)>
								<!ATTLIST RefTCExec
									ExCode		(er|ip|ok) ""
									ExcDur		NMTOKEN #IMPLIED
									RefUID		NMTOKEN #REQUIRED
									UID				NMTOKEN #IMPLIED
								>
							*/
						aUID = aTCExUIDLst[j];

						aTCExDBNode = m_xDB.getXMLsubTree( ref aUID );

						//xNode = tcNode.m_xNode.OwnerDocument.ImportNode( aTCExDBNode.m_xNode, true );
						xNode = tcNode.m_xDoc.ImportNode( aTCExDBNode.m_xNode, true );

						tcNode.m_xNode.AppendChild( xNode );
					}
				}
			}
		}

		// ---------------------------------
		private void assignEntry( ref ListViewItem p_lstVItem, ref string p_User ) {
			
			bool isAssgn;

			int iix;

			TCLstTag tag;
			TCLstEntry tcLstEnt;
			TCSLstEntry tcsLstEnt;

			isAssgn = p_User.Length > 0;

			tag = (TCLstTag)p_lstVItem.Tag;

			//ix = tag.m_Idx[0];
			//tcsLstEnt = (TCSLstEntry)m_TCSetLst[ix];

			if( tag.m_isTCSet ) {

				// assign all sub TCs and TC set and refresh stats

				//if( p_lstVItem.SubItems[1].Text == QNDefs.lstOperCollapse ) {
				iix = p_lstVItem.ImageIndex;

				if( (iix == 1) || (iix == 4) ) {

					collapseVEntry( p_lstVItem.Index );
				}
		
				tcsLstEnt = getTCSEntryByLstTag( tag );

				assignTCS( tcsLstEnt, isAssgn, ref p_User );

				resetParentsAss( p_lstVItem.Index );
			}
			else {

				//ix = tag.m_Idx[1];
				//TCLstEnt = (TCLstEntry)tcsLstEnt.m_TCLst[ix];

				tcLstEnt = getTCEntryByLstTag( tag );

				assignTC( tcLstEnt, isAssgn, ref p_User );

				resetParentsAss( p_lstVItem.Index );
			}

			p_lstVItem.SubItems[5].Text = p_User;

			updateAssStat();
		}

		// --------------------
		private void resetParentsAss( int p_Ix ) {

			int ix;

			TCLstTag tag;
			TCSLstEntry tcsLstEnt;

			tag = (TCLstTag)lstvTC.Items[p_Ix].Tag;

			if( tag.m_Lvl > 0 ) {

				ix = getParentTCSetIdx( p_Ix );

				lstvTC.Items[ix].SubItems[5].Text = "";

				tag = (TCLstTag)lstvTC.Items[ix].Tag;

				tcsLstEnt = getTCSEntryByLstTag( tag );

				tcsLstEnt.m_Assgn = "";

				if( tag.m_Lvl > 0 ) {

					resetParentsAss( ix );
				}
			}
		}

		// ------------------
		private void assignTC( TCLstEntry p_TCLstEnt, bool p_IsAssgn, ref string p_User  ) {

			if( p_IsAssgn ) {

				if( p_TCLstEnt.m_Assgn.Length < 1 ) {

					m_TCsAssgn++;
				}
			}
			else {

				if( p_TCLstEnt.m_Assgn.Length > 0 ) {

					m_TCsAssgn--;
				}
			}

			p_TCLstEnt.m_Assgn = p_User;
		}

		// ----------------
		private void assignTCS( TCSLstEntry p_TCSLstEnt, bool p_IsAssgn, ref string p_User ) {

			int i, x;

			TCLstEntBase aLstEnt;
			TCLstEntry tcLstEnt;
			TCSLstEntry tcsLstEnt;

			p_TCSLstEnt.m_Assgn = p_User;

			x = p_TCSLstEnt.m_TCLst.Count;

			for( i = 0; i < x; ++i ) {

				aLstEnt = (TCLstEntBase)p_TCSLstEnt.m_TCLst[i];

				if( aLstEnt.m_isSet ) {

					tcsLstEnt = (TCSLstEntry)p_TCSLstEnt.m_TCLst[i];

					assignTCS( tcsLstEnt, p_IsAssgn, ref p_User );
				}
				else {

					tcLstEnt = (TCLstEntry)p_TCSLstEnt.m_TCLst[i];

					assignTC( tcLstEnt, p_IsAssgn, ref p_User );
				}
			}
		}

		// ------------------
		private RsltXMLNode bldCmpgnDoc() {

			int i, x;

			RsltString rVal;

			RsltXMLNode aNode;

			RsltXMLNode CmpNode;
			RsltXMLNode tcsListNode;

			string val;
			
			TCSLstEntry aTCSLstEnt;

			/*
			<!ELEMENT Cmpgn ( Desc?, TCList ) >
				<!ATTLIST Cmpgn
					Appl			CDATA #IMPLIED
					Author		CDATA #IMPLIED
					DateTime	NMTOKEN #REQUIRED
					SoftRel		NMTOKEN #REQUIRED
					Status		(ce|cl|ex|op) ""
					Title			CDATA #REQUIRED
					UID				NMTOKEN #IMPLIED
				>
			*/

			string nodeName = "Cmpgn";
			CmpNode = new RsltXMLNode( nodeName );

			if( CmpNode.isOK() ) {

				//<?xml version="1.0"?>
				CmpNode.createXmlDecl( "1.0", "", "" );

				//<!DOCTYPE TestCase SYSTEM "QN.CmpgnV01.dtd">
				CmpNode.addSysDocTypeInfo( nodeName, QNDefs.dtdNameCm );

				//<!-- Generated by QA Navigator Campaign Manager V1.0.0.0-->
				string genCom = QNDefs.phrGenBy + m_QNTools.getApplInfo();
				CmpNode.addComment( genCom );

				CmpNode.addUID( m_uidCmpgn );
				
				val = m_QNTools.getComboSelVal( ref comboAppl );
				CmpNode.addAttribAsHtml( "Appl", val );

				CmpNode.addAttribAsHtml( "Author", txtOwner.Text );

				rVal = m_QNTools.chkVal( txtDate.Text, lblDate.Text );

				if( CmpNode.checkRslt( rVal ) ) {

					val = rVal.theString;

					rVal = m_QNTools.chkVal( txtTime.Text, lblTime.Text );

					if( CmpNode.checkRslt( rVal ) ) {

						val += "T" + rVal.theString;

						CmpNode.addAttrib( "DateTime", val );
					}				
				}
			}

			if( CmpNode.isOK() ) {

				val = m_QNTools.getComboSelVal( ref comboSoftRel );
				CmpNode.addAttribAsHtml( "SoftRel", val );

				val = m_QNTools.getComboSelVal( ref comboStat );
				CmpNode.addAttribAsHtml( "Status", val );

				rVal = m_QNTools.chkVal( txtTitle.Text, lblTitle.Text );

				if( CmpNode.checkRslt( rVal ) ) {

					CmpNode.addAttribAsHtml( "Title", rVal );
				}
			}
					
			if( CmpNode.isOK() ) {

				aNode = CmpNode.appTxtNodeAsHTML( "Desc", txtDesc.Text );
				aNode.addUID( m_uidDesc );
			}

			if( CmpNode.isOK() ) {

				/*
				<!ELEMENT TCSList (CmpgnTCSet*)>
					<!ATTLIST TCSList
						UID			NMTOKEN #IMPLIED
					>				
				*/

				tcsListNode = CmpNode.appNode( "TCSList" );

				tcsListNode.addUID( m_uidTCSLst );

				x = m_TCSetLst.Count;

				for( i = 0; i < x; ++i ) {

					aTCSLstEnt = (TCSLstEntry)m_TCSetLst[i];

					appTCSLstSub( tcsListNode, aTCSLstEnt );
				}
			}

			return CmpNode;
		}

		// ----------------------
		private void collapseVEntry( int p_idx ) {

			/* 2005-10-02
						int i, x, ix, nidx; 

						TCLstTag tag;
						TCSLstEntry entry;

						ListViewItem lItem;

						lItem = lstvTC.Items[p_idx];
						tag = (TCLstTag)lItem.Tag;

						if( tag.m_isTCSet ) {

							ix = tag.m_Idx[0];


							if( lItem.ImageIndex == 1 ) {

								entry = (TCSLstEntry)m_TCSetLst[ix];
							}
							else {

							}

							x = entry.m_TCLst.Count;

							nidx = p_idx + 1;

							for( i = 0; i < x; ++i ) {

								lstvTC.Items.RemoveAt( nidx );
							}
				

							//lstvTC.Items[p_idx].SubItems[1].Text = QNDefs.lstOperExpand;

							lstvTC.Items[p_idx].ImageIndex = 0;
						}
			*/		
			bool cont;

			int ix, iix, thisIix;
			int lvl;

			ListViewItem lvi;

			TCLstTag tag;

			lvi = lstvTC.Items[p_idx];

			thisIix = lvi.ImageIndex;
			
			tag = (TCLstTag)lvi.Tag;

			lvl = tag.m_Lvl;

			ix = p_idx + 1;

			if( ix >= lstvTC.Items.Count ) {

				cont = false;
			}
			else {

				cont = true;
			}

			while( cont ) {

				iix = lstvTC.Items[ix].ImageIndex;

				if( iix > thisIix ) {

					lstvTC.Items.RemoveAt( ix );

					if( ix >= lstvTC.Items.Count ) {

						cont = false;
					}
				}
				else {

					cont = false;
				}
			}

			lvi.ImageIndex = (3 * lvl);
		}

		// -----------------------
		private int clpsVTCPEntry( int p_idx ) {

			int i; 

			i = getParentTCSetIdx( p_idx );

			collapseVEntry( i );

			return i;
		}

		// -----------------------
		private void remSelfFromList( TCLstTag p_Tag ) {

			int i;
			int lvl;

			int[] idxLst;

			TCSLstEntry entry;

			idxLst = p_Tag.m_Idx;
			lvl = p_Tag.m_Lvl;

			if( lvl < 1 ) {

				m_TCSetLst.RemoveAt( idxLst[0] );
			}
			else {

				entry = (TCSLstEntry)m_TCSetLst[ idxLst[0] ];

				for( i = 1; i < lvl; ++i ) {

					entry = (TCSLstEntry)entry.m_TCLst[ idxLst[i] ];
				}

				entry.m_TCLst.RemoveAt( idxLst[i] );
			}
		}

		// ---------------------
		private void remTCEntryData( TCLstTag p_Tag, TCLstEntry p_TCLstEnt ) {
			
			int v;
			string val;

			val = p_TCLstEnt.m_ExpDur;

			if( val.Length > 0 ) {

				v = Convert.ToInt32( val );

				m_TotRemExDur -= v;
				m_TotDur -= v;

				propExpDur( p_Tag, v );
			}

			val = p_TCLstEnt.m_Assgn;

			if( val.Length > 0 ) {

				m_TCsAssgn--;
			}

			m_TotTCs--;
		}

		// ---------------------
		private void propExpDur( TCLstTag p_Tag, int p_ExDLess ) {

			int ed, i, lvl;
			string exD;

			TCSLstEntry tcsLstEnt;

			lvl = p_Tag.m_Lvl;

			tcsLstEnt = (TCSLstEntry)m_TCSetLst[ p_Tag.m_Idx[0]];

			for( i = 0; i < lvl; ) {

				exD = tcsLstEnt.m_ExpDur;

				ed = Convert.ToInt32( exD );

				ed -= p_ExDLess;

				tcsLstEnt.m_ExpDur = Convert.ToString( ed );

				++i;

				if( i < lvl ) {

					tcsLstEnt = (TCSLstEntry)tcsLstEnt.m_TCLst[ p_Tag.m_Idx[i] ];
				}
			}
		}

		// ---------------------
		/// <summary>
		/// Does not delete the item in lstvTC!
		/// Decrements, but does not update the statistics!
		/// </summary>
		/// <param name="p_ix"></param>
		private void delTCLstEntry( int p_Ix, TCLstTag p_Tag ) {

			int lstIx;

			TCLstEntry tcLstEnt;
			TCSLstEntry tcsLstEnt;

			//tcsLstEnt = (TCSLstEntry)m_TCSetLst[ p_Tag.m_Idx[0] ];

			lstIx = p_Tag.m_Idx[ p_Tag.m_Lvl ];
			tcsLstEnt = getParentTCSByLstTag( p_Tag );
			tcLstEnt = (TCLstEntry)tcsLstEnt.m_TCLst[ lstIx ];

			remTCEntryData( p_Tag, tcLstEnt );

			tcsLstEnt.m_TCLst.RemoveAt( lstIx );
		}

		// ---------------------
		private void delTCSLstEntDat( TCLstTag p_Tag, TCSLstEntry p_TCSLstEnt ) {
			
			int i, x;

			TCLstEntBase anEnt;
			TCLstEntry tcLstEnt;
			TCSLstEntry tcsLstEnt;

			x = p_TCSLstEnt.m_TCLst.Count;

			for( i = 0; i < x; ++i ) {

				anEnt = (TCLstEntBase)p_TCSLstEnt.m_TCLst[i];

				if( anEnt.m_isSet ) {

					tcsLstEnt = (TCSLstEntry)p_TCSLstEnt.m_TCLst[i];

					delTCSLstEntDat( p_Tag, tcsLstEnt );
				}
				else {

					tcLstEnt = (TCLstEntry)p_TCSLstEnt.m_TCLst[i];

					remTCEntryData( p_Tag, tcLstEnt );
				}
			}
		}

		// ---------------------
		/// <summary>
		/// Does not delete the item in lstvTC!
		/// Decrements, but does not update the statistics!
		/// </summary>
		/// <param name="p_Tag"></param>
		private void delTCSLstEntry( TCLstTag p_Tag ) {

			TCSLstEntry tcsLstEnt;
			
			//lvl = p_Tag.m_Lvl;

			tcsLstEnt = getTCSEntryByLstTag( p_Tag );

			delTCSLstEntDat( p_Tag, tcsLstEnt );

			remSelfFromList( p_Tag );
		}

		// ---------------------
		private void expandVEntry( int p_idx ) {
	
			bool isEx;

			int i, j, x, nidx;
			int lvl, nlvl;

			int[] idxLst;
			int[] pIdxLst;

			ListViewItem pLvi;
			ListViewItem lvi;

			TCLstTag tag;
			TCSLstEntry entry;

			TCLstEntBase anEnt;

			pLvi = lstvTC.Items[p_idx];

			tag = (TCLstTag)pLvi.Tag;

			lvl = tag.m_Lvl;

			if( lvl > 1 ) {

				// ----------------------<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
				Rslt rs = new Rslt( RsltStatVal.inError, "More than two levels of grouping is not suported." );

				m_GUIservice.dispError( rs );
			}

			if( tag.m_isTCSet & ( lvl < 2 ) ) {

				entry = getTCSEntryByLstTag( tag );

				pIdxLst = tag.m_Idx;

				x = entry.m_TCLst.Count;

				nidx = p_idx;

				nlvl = lvl + 1;

				// add the sub items to the list
				for( i = 0; i < x; ++i ) {

					isEx = false;

					anEnt = (TCLstEntBase)entry.m_TCLst[i];

					lvi = new ListViewItem();

					if( anEnt.m_isSet ) {

						lvi.ImageIndex = (3 * lvl) + 3;
					}
					else {

						lvi.ImageIndex = (3 * lvl) + 2;
					}

					idxLst = new int[3] { -1, -1, -1 };

					// copy the parent indexes
					for( j = 0; j < nlvl; ++j ) {

						idxLst[j] = pIdxLst[ j ];
					}

					idxLst[nlvl] = i;

					lvi.SubItems.Add( "" );
					lvi.SubItems.Add( "" );
					lvi.SubItems.Add( anEnt.m_Title );
					lvi.SubItems.Add( anEnt.m_ExpDur );
					lvi.SubItems.Add( anEnt.m_Assgn );
					lvi.SubItems.Add( anEnt.m_ExecTime );
					lvi.Tag = new TCLstTag( anEnt.m_isSet, nlvl, idxLst );
					
					lvi.UseItemStyleForSubItems = false;

					if( anEnt.m_isErr ) {

						lvi.SubItems[2].BackColor = Color.Firebrick;
						lvi.SubItems[2].ForeColor = Color.White;
					}

					if( anEnt.m_isSet ) {

						TCSLstEntry tcsEnt = (TCSLstEntry)entry.m_TCLst[i];

						if( tcsEnt.m_isAllEx ) {

							isEx = true;
						}
					}
					else {

						if( anEnt.m_ExecTime.Length > 0 ) {

							isEx = true;
						}
					}

					if( isEx ) {

						lvi.SubItems[1].BackColor = Color.Green;
						lvi.SubItems[1].ForeColor = Color.White;
					}


					nidx++;

					lstvTC.Items.Insert( nidx, lvi );
				}

				//lstvTC.Items[p_idx].SubItems[1].Text = QNDefs.lstOperCollapse;

				pLvi.ImageIndex = (3 * lvl) + 1;
			}
		}

		// -----------------------
		// Fills the list of TC sets with the first level of TC sets.
		private void fillTCLst() {

			int i, x;

			TCSLstEntry tcsLstEnt;

			x = m_TCSetLst.Count;

			for( i = 0; i < x; ++i ) {

				tcsLstEnt = (TCSLstEntry)m_TCSetLst[i];

				// List View
				ListViewItem lvi;

				int[] idxLst = new int[3];

				idxLst[0] = i;
				idxLst[1] = -1;
				idxLst[2] = -1;

				// LstOper, Title, Duration, Assignee, X-Time
				lvi = new ListViewItem();
				lvi.ImageIndex = 0;
				lvi.SubItems.Add( "" );
				lvi.SubItems.Add( "" );
				lvi.SubItems.Add( tcsLstEnt.m_Title );
				lvi.SubItems.Add( tcsLstEnt.m_ExpDur );
				lvi.SubItems.Add( tcsLstEnt.m_Assgn );
				lvi.SubItems.Add( "" );
				lvi.Tag = new TCLstTag( true, 0, idxLst );

				lvi.UseItemStyleForSubItems = false;

				if( tcsLstEnt.m_isErr ) {

					// at least one TC is in error
					lvi.SubItems[2].BackColor = Color.Firebrick;
					lvi.SubItems[2].ForeColor = Color.White;
				}

				if( tcsLstEnt.m_isAllEx ) {

					// all TCs have been executed
					lvi.SubItems[1].BackColor = Color.Green;
					lvi.SubItems[1].ForeColor = Color.White;
				}

				/*
					if( tcsLstEnt.m_ExpDur.Length > 0 ) {

						m_TotDur += Convert.ToInt32( tcsLstEnt.m_ExpDur );
					}
					*/

				lstvTC.Items.Add( lvi );
			}
		}

		// -----------------------
		private TCLstEntry getTCEntryByLstTag( TCLstTag p_Tag ) {

			TCLstEntry tcEnt;
			TCSLstEntry tcsEnt;

			tcsEnt = getParentTCSByLstTag( p_Tag );

			tcEnt = (TCLstEntry)tcsEnt.m_TCLst[ p_Tag.m_Idx[ p_Tag.m_Lvl ] ];

			return tcEnt;
		}

		// -----------------------
		private TCSLstEntry getParentTCSByLstTag( TCLstTag p_Tag ) {

			int i;
			int lvl;

			int[] idxLst;

			TCSLstEntry tcsEnt;

			tcsEnt = null;
			
			lvl = p_Tag.m_Lvl;

			if( lvl > 0 ) {

				idxLst = p_Tag.m_Idx;

				tcsEnt = (TCSLstEntry)m_TCSetLst[ idxLst[0] ];

				for( i = 1; i < lvl; ++i ) {

					tcsEnt = (TCSLstEntry)tcsEnt.m_TCLst[ idxLst[i] ];
				}
			}

			return tcsEnt;
		}

		// -----------------------
		private TCSLstEntry getTCSEntryByLstTag( TCLstTag p_Tag ) {

			int i, x;

			int[] idxLst;

			TCSLstEntry entry;

			idxLst = p_Tag.m_Idx;

			entry = (TCSLstEntry)m_TCSetLst[ idxLst[0] ];

			x = p_Tag.m_Lvl + 1;

			for( i = 1; i < x; ++i ) {

				entry = (TCSLstEntry)entry.m_TCLst[ idxLst[i] ];
			}

			return entry;
		}

		// -----------------------
		private bool getExStat( ref ArrayList p_TCExLst ) {

			int i, x;

			TCExLstEntry TCExEnt;

			bool isOK = true;

			x = p_TCExLst.Count;
 
			for( i = 0; i < x; ++i ) {

				TCExEnt = (TCExLstEntry)p_TCExLst[ i ];

				if( TCExEnt.m_ExCode.CompareTo( "er" ) == 0 ) {

					isOK = false;

					i = x;
				}
			}

			return isOK;
		}

		// -----------------------
		/// <summary>
		/// Caution: we're making heavy use of the image indexes to control the logic!
		/// </summary>
		/// <param name="p_idx"></param>
		/// <returns></returns>
		private int getParentTCSetIdx( int p_idx ) {

			int i, iix, mix; 

			TCLstTag tag;

			i = p_idx;

			if( i > 0 ) {

				mix = lstvTC.Items[p_idx].ImageIndex;

				do {

					i--;

					tag = (TCLstTag)lstvTC.Items[i].Tag;

					iix = lstvTC.Items[i].ImageIndex;

				} while( ( !(tag.m_isTCSet && (iix < mix)) ) && (i > 0) );
			}

			return i;
		}

		//----------------------
		private void handleErr( IRslt p_Res, string p_Msg ) {

			setAppStat( AppStat.Error );

			m_Logger.write2Log( ref p_Res );

			addLog( p_Msg );

			issueErr( p_Msg );
		}

		//-----------------------
		private void handleIfErr( IRslt p_Res, string p_Msg ) {

			if( p_Res.notOK() ) {

				handleErr( p_Res, p_Msg );
			}
		}
		
		//----------------------------
		private void handleExcp( Exception p_Excp ) {
			
			try {

				setAppStat( AppStat.Error );

				addLog( "Exception '" + p_Excp.Message + "'");

				m_Logger.write2Log( ref p_Excp );

				m_GUIservice.dispExcp( p_Excp );
			}
			catch {

				string msg = "An exception has occured at a very early stage of the"
					+ " initialization of the program. So early that the program is not able"
					+ " to provide you any aid. Errors at this stage are mostly due to"
					+ " bad configuration. If the configuration has been changed recently,"
					+ " switch back to the former version, if you can. In other cases please"
					+ " refer to the list of known problems in your documentation.";

				MessageBox.Show(  msg, "Early Error Occured", MessageBoxButtons.OK, MessageBoxIcon.Error );
			}
		}
		
		// -----------------------------
		/// <summary>
		/// Displays a text dialog. Detects, if the dialog is supposed to allow editing.
		/// If so, the Rslt is written back to p_Sender. 
		/// </summary>
		/// <param name="p_Sender"></param>
		/// <param name="p_Title"></param>
		private void handleTxtPop( object p_Sender, string p_Title ) {

			try {

				bool forEdit;
				DialogResult dRes;
				TextBox tBox;

				tBox = (TextBox)p_Sender;
				
				forEdit = !(tBox.ReadOnly);
			
				setAppStat( AppStat.Proc );

				frmTxtWin txtWin;
		
				txtWin = new frmTxtWin( forEdit, ref m_Presets );

				txtWin.Text = p_Title;

				txtWin.setText( tBox.Text );

				txtWin.TopMost = true;

				dRes = txtWin.ShowDialog();

				if( DialogResult.OK == dRes ) {

					if( forEdit ) {

						tBox.Text = txtWin.m_Text;
					}

					setAppStat( AppStat.OK );
				}

				txtWin.Dispose();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
				
				handleExcp( excp );
			}	
		}
	
		// -----------------------------------
		private Rslt init() {
frmCmpgnMgr.CheckForIllegalCrossThreadCalls = false;
			int x, y;

			x = this.Width;
			y = this.Height;	

			// resizing stuff
			m_tabc1DH = y - tabControl1.Height;
			m_tabc1DW = x - tabControl1.Width;
			
			m_lstTCSDW = x - lstvTC.Width;
			m_lstTCSDH = y - lstvTC.Height;
			m_colDW = x - lstvTC.Columns[3].Width;

			m_txtStatDT = y - txtStat.Top;
			m_comboLogDT = y - comboLog.Top;

			m_TCsAssgn = 0;
			m_TotBad = 0;
			m_TotDur = 0;
			m_TotEx = 0;
			m_TotExDur = 0;
			m_TotRemExDur = 0;
			m_TotTCs = 0;

			Rslt res = new Rslt( RsltStatVal.isOK );

			m_QNTools = new QNTools();

			m_QNphrase = m_QNTools.m_QNphrase;

			m_GUIservice = new QNGUIservice( m_QNphrase );

			m_Presets = new QNpresets( m_QNTools );

			setClrs();

			m_Logger.write2Log( m_QNTools.getApplInfo() );

			setLabels();

			m_TCSetLst = new ArrayList();

			if( m_Presets.notOK() ) {

				res.setRsltStat( m_Presets, m_QNphrase.errPresetFrm );
			}
			else {
			
				m_CmpSelPresets = new CmpSelPresets( m_Presets.m_Author );
				m_TCSSelPresets = new TCSelPresets();

                m_DB = new RGSQL2( m_Presets.m_DBloc, m_Presets.m_DBname, m_Presets.m_DBuser, m_Presets.m_DBpw );

				if( res.checkRslt( m_DB ) ) {

    				m_xDB = new XMLDB( m_DB, m_Presets.m_UIDsrvLoc );

					m_DataMiner = new QNDataMiner( m_xDB );
				}
			}

			if( res.isOK() ) {

				reset();

				setAppStat( AppStat.OK );

				addLog( BTools.getNowISODate() + " " + m_QNphrase.msgSesStart );
			}
			
			handleIfErr( res, m_QNphrase.errInitFailed );

			return res;
		}

		//------------------------------
		private void issueErr( string msg ) {

			MessageBox.Show( msg, m_QNphrase.lblErr, MessageBoxButtons.OK, MessageBoxIcon.Error );
		}

		//------------------------------
		private Rslt getCmpgnDoc() {

			Rslt res = new Rslt( true );

			XMLDBNode xDBNode;

			xDBNode = m_xDB.getXMLsubTree( ref m_loadUID );

			if( res.checkRslt( xDBNode )  ) {

				m_LoadDoc = xDBNode.m_xDoc;
			}
			else {

				handleErr( res, m_QNphrase.errCmpgnLoadFailed );
			}

			return res;
		}
		
		//---------------------------
		private Rslt loadCmpgnDoc( XmlDocument p_XDoc ) {

			Rslt res;
			RsltString xVal;

			RsltXMLNode aNode;

			RsltXMLNode CmpgnNode;

			RsltXMLNode tcsListNode;

			string val;

			XmlNodeList tcsNodeLst;
			XmlNodeList nodeLst;

			/*
				<!ELEMENT Cmpgn ( Desc?, TCList ) >
					<!ATTLIST Cmpgn
						Appl			CDATA #IMPLIED
						Author		CDATA #IMPLIED
						Date			NMTOKEN #REQUIRED
						SoftRel		NMTOKEN #REQUIRED
						Status		(ce|cl|ex|op) ""
						Title			CDATA #REQUIRED
						Time			NMTOKEN #REQUIRED
						UID				NMTOKEN #IMPLIED
					>
			*/

			res = new Rslt( true );

			nodeLst = p_XDoc.SelectNodes( "/Cmpgn" );

			#region CmpgnAttrs

			if( 1 != nodeLst.Count ) {

				m_Logger.write2Log( "Top node 'Cmpgn' not found." );

				res.setInError( m_QNphrase.errInvXML );
			}
			else {

				CmpgnNode = nodeLst.Item( 0 );

				m_uidCmpgn = CmpgnNode.UID;

				xVal = CmpgnNode.getAttrValFromHtml( "Appl" );
				m_QNTools.selByDataLstVal( ref comboAppl, xVal.theString );

				xVal = CmpgnNode.getAttrValFromHtml( "Author" );
    
				txtOwner.Text = xVal.theString;

				xVal = CmpgnNode.getAttrVal( "DateTime" );

				if( res.checkRslt( xVal ) ) {

					val = BTools.getDateFromISODateTime( xVal.theString );   
					txtDate.Text = val;

					val = BTools.getTimeFromISODateTime( xVal.theString );   
					txtTime.Text = val;

					xVal = CmpgnNode.getAttrValFromHtml( "SoftRel" );
					m_QNTools.selByDataLstVal( ref comboSoftRel, xVal.theString );

					xVal = CmpgnNode.getAttrVal( "Status" );

					val = xVal.theString;

					if( val != "op" ) {

						m_IsOpen = false;

						m_QNTools.remByDataLstVal( ref comboStat, ref m_CStatLst, "op" );
					}
					
					if( val == "cl" ) {

						m_QNTools.remByDataLstVal( ref comboStat, ref m_CStatLst, "ex" );
						m_QNTools.remByDataLstVal( ref comboStat, ref m_CStatLst, "ce" );

						m_IsClosed = true;
					}

					m_QNTools.selByDataLstVal( ref comboStat, val );

					// Title
					xVal = CmpgnNode.getAttrValFromHtml( "Title" );

					txtTitle.Text = xVal.theString;

					#endregion

					aNode = CmpgnNode.getSubNode( "Desc" );
					
					if( aNode.isOK() ) {

						txtDesc.Text = aNode.textFromHtml;
						m_uidDesc = aNode.UID;
					}

					/*
					<!ELEMENT TCSList (CmpgnTCSet*)>
						<!ATTLIST TCSList
							UID			NMTOKEN #IMPLIED
						>						
					*/

					nodeLst = CmpgnNode.m_xNode.SelectNodes( "./TCSList" );

					if( nodeLst.Count == 1 ) {

						tcsListNode = nodeLst.Item( 0 );

						m_uidTCSLst = tcsListNode.UID;

						tcsNodeLst = tcsListNode.m_xNode.SelectNodes( "./CmpgnTCSet" );

						loadCTCSetLst( tcsNodeLst, m_TCSetLst );

						fillTCLst();
					}
				}
			}

			return res;
		}

		//--------------------------
		private Rslt loadCmpgn( string p_loadUID ) {

			m_loadUID = p_loadUID;

			Rslt res = new Rslt( true );

			try {

				reset();

				/*
				Thread loadThread = new Thread(new ThreadStart(getCmpgnDoc));

				// Start the thread.
				loadThread.Start();
				*/

				m_LoadDoc = null;

				res = getCmpgnDoc();

				if( res.isOK() ) {

					menuSave.Enabled = true;

					res = loadCmpgnDoc( m_LoadDoc );

					if( res.isOK() ) {

						setLoaded();
					}

					if( m_IsClosed ) {

						menuSave.Enabled = false;
					}

					updateStats();
				}

				if( res.notOK() ) {

					m_Logger.write2Log( "Loading of '" +  p_loadUID + "' failed." );

					handleErr( res, m_QNphrase.errTCSLoadFailed );
				}
				else {

					setAppStatOK( res.isOK() );
					addLog( String.Format( m_QNphrase.msgLoaded, txtTitle.Text ) );
				}
			}
			catch( Exception e ) {
		
				handleExcp( e );
				res.setRsltByExcp( e );
			}

			return res;
		}

		// -----------------------
		private TCSInfo loadCTCSetLst( XmlNodeList p_TCSnodeLst, ArrayList p_TCSetLst ) {

			bool hasErr, isOK, sAllEx;

			int i, j, x, y;

			int dur, exDur, exCnt;

			RsltString xVal;
			RsltXMLNode tcNode;
			RsltXMLNode TCSnode;
 
			TCSInfo subTCSInfo;
			TCSInfo tcsInfo;

			TCLstEntry tcLstEnt;
			TCSLstEntry tcsLstEnt;

			XmlNodeList tcNodeLst;

			tcsInfo = new TCSInfo();

			x = p_TCSnodeLst.Count;

			for( i = 0; i < x; ++i ) {

				#region TCSLstEnt

				/*
				<!ELEMENT CmpgnTCSet (RefCTC*)>
					<!ATTLIST CmpgnTCSet
						Assignd	CDATA #IMPLIED
						ExpDur	NMTOKEN #IMPLIED
						RefUID	NMTOKEN #REQUIRED
						Title		CDATA #REQUIRED
						UID			NMTOKEN #IMPLIED
					>
				*/

				hasErr = false;
				sAllEx = true;

				tcsLstEnt = new TCSLstEntry();

				TCSnode = p_TCSnodeLst.Item( i );

				xVal = TCSnode.getAttrValFromHtml( "Assignd" );
				tcsLstEnt.m_Assgn = xVal.theString; 

				xVal = TCSnode.getAttrVal( "ExpDur" );
				tcsLstEnt.m_ExpDur = xVal.theString; 

				xVal = TCSnode.getAttrVal( "RefUID" );
				tcsLstEnt.m_RefUID = xVal.theString;

				xVal = TCSnode.getAttrValFromHtml( "Title" );
				tcsLstEnt.m_Title = xVal.theString; 

				tcsLstEnt.m_UID = TCSnode.UID;

				// The sub TC sets
				tcNodeLst = TCSnode.m_xNode.SelectNodes( "./CmpgnTCSet" );

				if( tcNodeLst.Count > 0 ) {

					subTCSInfo = loadCTCSetLst( tcNodeLst, tcsLstEnt.m_TCLst );

					hasErr = subTCSInfo.m_isErr;

					sAllEx = subTCSInfo.m_isAllEx;
				}

				// The sub TCs
				tcNodeLst = TCSnode.m_xNode.SelectNodes( "./RefCTC" );

				y = tcNodeLst.Count;

				//TCSdur = 0;

				//2005-10-05 tcsLstEnt.m_TCLst = new RsltLst();

				exCnt = 0;

				for( j = 0; j < y; ++j ) {

					#region TCLstEnt

					/*
					<!ELEMENT RefCTC (RefTCExec*)>
						<!ATTLIST RefCTC
							Assignd			CDATA #IMPLIED
							ExpDur			NMTOKEN #IMPLIED
							RefUID			NMTOKEN #REQUIRED
							Title				CDATA #REQUIRED
							UID					NMTOKEN #IMPLIED
						>
					*/

					tcLstEnt = new TCLstEntry();

					tcNode = tcNodeLst.Item( j );

					xVal = tcNode.getAttrValFromHtml( "Assignd" );
					tcLstEnt.m_Assgn = xVal.theString; 

					if( xVal.theString.Length > 0 ) {

						m_TCsAssgn++;
					}

					xVal = tcNode.getAttrVal( "ExpDur" );
					tcLstEnt.m_ExpDur = xVal.theString; 

					if( xVal.theString.Length > 0 ) {

						dur = Convert.ToInt32( xVal.theString );
						m_TotDur += dur;
					}
					else {

						dur = 0;
					}

					xVal = tcNode.getAttrVal( "RefUID" );
					tcLstEnt.m_RefUID = xVal.theString; 

					xVal = tcNode.getAttrValFromHtml( "Title" );
					tcLstEnt.m_Title = xVal.theString; 

					tcLstEnt.m_UID = tcNode.UID;

					//duplicate with loadTCExInfo()
					//dur = tcLstEnt.loadTCEx( ref tcNode );

					//TCSdur += dur;

					tcLstEnt.m_TCExLst = new ArrayList();

					exDur = loadTCExInfo( ref tcNode, ref tcLstEnt );

					if( exDur > 0 ) {

						tcLstEnt.m_ExecTime = exDur.ToString("d");

						exCnt++; 
					}
					else {

						m_TotRemExDur += dur;
					}

					isOK = getExStat( ref tcLstEnt.m_TCExLst );

					if( !isOK ) {

						tcLstEnt.m_isErr = true;
						hasErr = true;
					}

					#endregion

					tcsLstEnt.m_TCLst.Add( tcLstEnt );
				}

				#endregion

				m_TotTCs += y;

				tcsLstEnt.m_isAllEx = (exCnt == y) && sAllEx;
				tcsLstEnt.m_isErr = hasErr;

				p_TCSetLst.Add( tcsLstEnt );
			
				tcsInfo.m_isAllEx &= tcsLstEnt.m_isAllEx;
				tcsInfo.m_isErr |= tcsLstEnt.m_isErr;
			}

			return tcsInfo;
		}

		// -----------------------
		private int loadTCExInfo( ref RsltXMLNode p_TCnode, ref TCLstEntry p_TCLstEnt ) {

			bool isBad;
			int i, x;
			int exDur;

			RsltString xVal;
			RsltXMLNode TCExNode;
			TCExLstEntry TCExEnt;
			XmlNodeList TCExnodeLst;

			/*
			<!ELEMENT RefTCExec (EMPTY)>
				<!ATTLIST RefTCExec
					DateTime	NMTOKEN #REQUIRED
					ExCode		(er|ok) ""
					ExcDur		NMTOKEN #IMPLIED
					RefUID		NMTOKEN #REQUIRED
					UID				NMTOKEN #IMPLIED
				>
				*/

			isBad = false;

			exDur = -1;

			TCExnodeLst = p_TCnode.m_xNode.SelectNodes( "./RefTCExec" );

			x = TCExnodeLst.Count;
						
			for( i = 0; i < x; ++i ) {

				TCExEnt = new TCExLstEntry();

				TCExNode = TCExnodeLst.Item( i );

				xVal = TCExNode.getAttrVal( "DateTime" );
				TCExEnt.m_DateTime = xVal.theString; 

				xVal = TCExNode.getAttrValFromHtml( "ExCode" );
				TCExEnt.m_ExCode = xVal.theString; 

				if( TCExEnt.m_ExCode.CompareTo( "er" ) == 0 ) {

					isBad = true;
				}

				xVal = TCExNode.getAttrVal( "ExcDur" );
				TCExEnt.m_ExcDur = xVal.theString; 

				exDur += Convert.ToInt32( TCExEnt.m_ExcDur );				

				xVal = TCExNode.getAttrVal( "RefUID" );
				TCExEnt.m_RefUID = xVal.theString; 	

				p_TCLstEnt.m_TCExLst.Add( TCExEnt );
			}

			if( x > 0 ) {

				exDur /= x;

				if( exDur < 1 ) {

					exDur = 1;
				}

				m_TotExDur += exDur;

				m_TotEx++;

				if( isBad ) {

					m_TotBad++;
				}
			}

			return exDur;
		}

		//-------------------------------------------------------------------------
		private void reset() {

			txtDesc.Text = "";
			txtTitle.Text = "";

			resetTCLst();

			//2005-10-03
			//updateStats();
			//m_TCSetLst.Clear();
			//lstvTC.Items.Clear();
			//resetStat();

			txtDesc.Text = "";

			m_CStatLst = new DataLst( m_Presets.m_CmpgnStatLst );

			menuDel.Enabled = false;
			menuSaveNew.Enabled = false;
			menuPrint.Enabled = false;
			menuUID2Clip.Enabled = false;
			
			setUpAppl();

			reset4New();

			reset2Open();

			resetUIDs();
		}

		
		//-------------------------------------------------------------------------
		private void reset2Open() {
			
			m_IsClosed = false;
			m_IsOpen = true;
			
			m_QNTools.reFillUpCombo( ref comboStat, ref m_CStatLst, 0);

			m_QNTools.selByDataLstVal( ref comboStat, "op" );

			menuRefLst.Enabled = false;
		}

		//-------------------------------------------------------------------------
		private void reset4New() {
			
			txtOwner.Text = m_Presets.m_Author;

			txtDate.Text = BTools.getNowISODate();
			txtTime.Text = BTools.getNowISOTime();
		}


		//--------------------------
		private void reset4Clone() {

			int i, x;

			TCSLstEntry entry;

			reset4New();

			x = m_TCSetLst.Count;

			for( i = 0; i < x; ++i ) {

				entry = (TCSLstEntry)m_TCSetLst[ i ];

				resetTCExLst( entry );
			}
			
			reset2Open();

			resetUIDs();
		}

		//--------------------------
		private void resetTCExLst( TCSLstEntry p_TCSentry ) {

			ArrayList TCLst;

			int i, x;

			TCLstEntry TCDat;
			TCLstEntBase anEnt;
			TCSLstEntry aTCSLstEnt;

			TCLst = p_TCSentry.m_TCLst;

			x = TCLst.Count;

			for( i = 0; i < x; ++i ) {

				anEnt = (TCLstEntBase)TCLst[ i ];

				if( anEnt.m_isSet ) {

					aTCSLstEnt = (TCSLstEntry)TCLst[ i ];

					resetTCExLst(  aTCSLstEnt );
				}
				else {
			
					TCDat = (TCLstEntry)TCLst[i];

					TCDat.m_TCExLst.Clear();
				}
			}
		}


		//--------------------------
		private void resetTCLst() {
			
			m_TCSetLst.Clear();

			lstvTC.Items.Clear();

			resetStat();
		}
	
		//--------------------------
		private void resetStat() {

			m_TCsAssgn = 0;
			m_TotBad = 0;
			m_TotDur = 0;
			m_TotEx = 0;
			m_TotExDur = 0;
			m_TotRemExDur = 0;
			m_TotTCs = 0;

			txtRemExFore.Text = "";
			txtTCsAssgn.Text = "";
			txtTCsAssgnPc.Text = "";
			txtTCsNotAssgn.Text = "";
			txtTotBad.Text = "";
			txtTotBadPc.Text = "";
			txtTotDur.Text = "";
			txtTotEx.Text = "";
			txtTotExDur.Text = "";
			txtTotExPc.Text = "";
			txtTotNotEx.Text = "";
			txtTotRemExDur.Text = "";
			txtTotRemExDurPc.Text = "";
			txtTotTCs.Text = "";
		}

		//--------------------------
		// + the status to "open"
		private void resetUIDs() {

			int i, x;
			TCSLstEntry entry;

			m_uidCmpgn = "";
			m_uidDesc = "";
			m_uidTCSLst = "";
			
			x = m_TCSetLst.Count;

			for( i = 0; i < x; ++i ) {

				entry = (TCSLstEntry)m_TCSetLst[ i ];

				resetTCSLstUIDs( entry );
			}
		}

		// -------------------	
		private void resetTCSLstUIDs( TCSLstEntry p_TCSLstEnt ) {

			int i, x;

			ArrayList TCLst;

			TCLstEntBase anEnt;
			TCLstEntry TCDat;
			TCSLstEntry aTCSLstEnt;

			TCLst = p_TCSLstEnt.m_TCLst;

			x = TCLst.Count;

			for( i = 0; i < x; ++i ) {

				anEnt = (TCLstEntBase)TCLst[ i ];

				if( anEnt.m_isSet ) {

					aTCSLstEnt = (TCSLstEntry)TCLst[ i ];

					resetTCSLstUIDs( aTCSLstEnt );
				}
				else {
				
					TCDat = (TCLstEntry)TCLst[i];

					TCDat.m_UID = "";
				}
			}

			p_TCSLstEnt.m_UID = "";
		}

		//---------------------------
		private RsltString runTCExDial( ref ArrayList p_ExLst ) {

			RsltString uid = new RsltString();

			try {

				int i, x;

				ArrayList uidLst = new ArrayList();

				TCExLstEntry TCExEnt;

				setAppStat( AppStat.Proc );

				x = p_ExLst.Count;

				for( i = 0; i < x; ++i ) {

					TCExEnt = (TCExLstEntry)p_ExLst[ i ];

					uidLst.Add( TCExEnt.m_RefUID );
				}

				frmTCExSel dialTCExSel = new frmTCExSel( ref m_xDB, uidLst, ref m_Presets );

				DialogResult dRes = dialTCExSel.ShowDialog();

				if( dialTCExSel.m_RsltLst.Count > 0 ) {

					uid.theString = (string)dialTCExSel.m_RsltLst[0];
				}

				setAppStat( AppStat.OK );

				dialTCExSel.Dispose();
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}

			return uid;
		}

		//---------------------------
		private void setAppStat( AppStat p_Stat ) {

			switch( p_Stat) {

				case AppStat.OK:

					txtStat.BackColor = m_Presets.m_ClrStatOK;
					txtStat.ForeColor = Color.White;
					txtStat.Text = m_QNphrase.lblOK;
					break;

				case AppStat.Proc:

					txtStat.BackColor = m_Presets.m_ClrStatProc;
					txtStat.ForeColor = Color.Black;
					txtStat.Text = m_QNphrase.lblProcng;
					break;

				case AppStat.Error:

					txtStat.BackColor = m_Presets.m_ClrStatErr;
					txtStat.ForeColor = Color.White;
					txtStat.Text =  m_QNphrase.lblErr;
					break;
			}

			this.Refresh();			
		}

		//---------------------------------
		private void setAppStatOK( bool p_IsOK ) {

			if( p_IsOK ) {

				setAppStat( AppStat.OK );
			}
			else {

				setAppStat( AppStat.Error );
			}
		}

		//--------------------------------
		private RsltString saveCmpgn() {
				
			RsltXMLNode xNode;

			RsltString UID = new RsltString();

			xNode = bldCmpgnDoc();

			if( xNode.notOK() ) {

				string msg = String.Format( m_QNphrase.errCrtngFailed, txtTitle.Text );

				handleErr( xNode, msg );

				UID.setInError( msg );
			}
			else {

				if( m_IsOpen ) {

					UID = m_xDB.importXML( ref xNode.m_xDoc );

					if( m_xDB.notOK() ) {

						handleErr( m_xDB, m_QNphrase.errTCSSaveFailed );

						m_xDB.resetRslt();
					}
				}
				else {

					RsltString msg;

					UID.setOK();

					msg = m_DataMiner.mergeCmpgn( xNode, true );

					if( UID.checkRslt( msg ) ) {

						UID.theString = m_loadUID;
					}
				}
			}

			return UID;
		}

		//-------------------------------------------------------------------------
		private void setClrs() {

			this.BackColor = m_Presets.m_ClrPnlBck;		
			this.ForeColor = m_Presets.m_ClrPnlFor;

			//Control cntrl = (Control)tabControl1;
			//cntrl.BackColor = m_Presets.m_ClrPnlBck;
			//tabControl1.BackColor = m_Presets.m_ClrPnlBck;

			tabStat.BackColor = m_Presets.m_ClrPnlBck;
			tabStat.ForeColor = m_Presets.m_ClrPnlFor;

			tabTCLst.BackColor = m_Presets.m_ClrPnlBck;
			tabTCLst.ForeColor = m_Presets.m_ClrPnlFor;

			panel1.BackColor = m_Presets.m_ClrPnlBck;
			panel1.ForeColor = m_Presets.m_ClrPnlFor;
				
			comboAppl.BackColor = m_Presets.m_ClrTxtBck;
			comboLog.BackColor = m_Presets.m_ClrTxtBck;
			comboSoftRel.BackColor = m_Presets.m_ClrTxtBck;
			comboStat.BackColor = m_Presets.m_ClrTxtBck;

			lstvTC.BackColor = m_Presets.m_ClrTxtBck;

			txtDate.BackColor = m_Presets.m_ClrTxtBck;
			txtDesc.BackColor = m_Presets.m_ClrTxtBck;
			txtOwner.BackColor = m_Presets.m_ClrTxtBck;
			txtTime.BackColor = m_Presets.m_ClrTxtBck;
			txtTitle.BackColor = m_Presets.m_ClrTxtBck;
		}

		// ----------------------------------------------------
		private void setLoaded() {

			menuDel.Enabled = true;
			menuSaveNew.Enabled = true;
			menuPrint.Enabled = true;
			menuUID2Clip.Enabled = true;

			if( !m_IsOpen ) {

				menuRefLst.Enabled = true;
			}
		}

		// ----------------------------------------------------
		private void setUpAppl() {

			m_QNTools.reFillUpCombo( ref comboSoftRel,ref m_Presets.m_TstSoftRelLst, 0);

			m_QNTools.reFillUpCombo( ref comboAppl,ref m_Presets.m_ApplLst, 0);
 		}


		// ---------------------
		private void updateStats() {

			int val;
			double totExPc, totBadPc, totRemExPc, totRemExFore;

			if( m_TotTCs > 0 ) {

				totExPc = m_TotEx * 100;
				totExPc /= m_TotTCs;

				totBadPc = m_TotBad * 100;
				totBadPc /= m_TotTCs;
			}
			else {

				totExPc = 0;
				totBadPc = 0;
			}

			if( m_TotDur > 0 ) {

				totRemExPc = m_TotRemExDur * 100;
				totRemExPc /= m_TotDur;

				totRemExFore = m_TotExDur * totRemExPc;
				totRemExFore /= (1 - totRemExPc);
			}
			else {

				totRemExPc = 0;
				totRemExFore = 0;
			}

			updateAssStat();

			txtTotTCs.Text = Convert.ToString( m_TotTCs );

			txtTotEx.Text = Convert.ToString( m_TotEx );

			val = m_TotTCs - m_TotEx;
			txtTotNotEx.Text = Convert.ToString( val );

			txtTotExPc.Text = totExPc.ToString("0.0");


			txtTotDur.Text = Convert.ToString( m_TotDur );

			txtTotRemExDur.Text = Convert.ToString( m_TotRemExDur );

			txtTotRemExDurPc.Text = totRemExPc.ToString("0.0");

			txtTotExDur.Text = Convert.ToString( m_TotExDur );
			txtRemExFore.Text = totRemExPc.ToString("0.0");

			txtTotBad.Text = Convert.ToString( m_TotBad );

			txtTotBadPc.Text = totBadPc.ToString("0.0");		
		}

		// ---------------------
		private void updateAssStat() {

			int val;
			double assgnPc;

			assgnPc = 0;

			if( m_TotTCs > 0 ) {

				assgnPc = m_TCsAssgn * 100;
				assgnPc /= m_TotTCs;
			}

			txtTCsAssgn.Text = Convert.ToString( m_TCsAssgn );

			val = m_TotTCs - m_TCsAssgn;
			txtTCsNotAssgn.Text = Convert.ToString( val );

			txtTCsAssgnPc.Text = assgnPc.ToString("0.0");		
		}

		// ---------------------
		private void updParentTCSentries( int p_ix, TCLstTag p_Tag ) {

			int pix;

			if( p_Tag.m_Lvl > 0 ) {
			
				pix = getParentTCSetIdx( p_ix );
				updTCSentries( pix, p_Tag );
			}
		}

		// ---------------------
		private void updTCSentries(int p_pix, TCLstTag p_Tag)
		{
			string val;

			TCLstTag tag;

			TCSLstEntry tcsLstEnt;

			if( ( p_Tag.m_Lvl > 0 ) && ( p_pix > -1 ) ) {

				tcsLstEnt = getParentTCSByLstTag(p_Tag);

				val = tcsLstEnt.m_ExpDur;

				lstvTC.Items[p_pix].SubItems[4].Text = val;

				tag = (TCLstTag)lstvTC.Items[p_pix].Tag;

				if (tag.m_Lvl > 0)
				{

					updParentTCSentries(p_pix, tag);
				}
			}
		}

		#endregion
	
		#region I18N

		//---------------------------------
		private void setLabels() {

			string pcStr = " (%)";

			this.Text = m_QNphrase.lblCmpgnMgr;

			ctxtTCSLstAdd.Text = m_QNphrase.mlblAddTCSet;
			ctxtTCSLstAssgn.Text = m_QNphrase.mlblAssgn;
			ctxtTCSLstClear.Text = m_QNphrase.mlblClearAssgn;
			ctxtTCSLstRem.Text = m_QNphrase.mlblRemove;
			ctxtTCSLstView.Text = m_QNphrase.mlblView;
			ctxtTCSLstViewExec.Text = m_QNphrase.mlblViewExec;

			ctxtLogEntry.Text = m_QNphrase.mlblDispEntry;

			lblAppl.Text = m_QNphrase.lblAppl;
			lblDate.Text = m_QNphrase.lblDate;
			lblDesc.Text = m_QNphrase.lblDesc;
			lblExTimeRemFore.Text = m_QNphrase.lblExTimeRemFore;
			lblOwner.Text = m_QNphrase.lblOwner;
			lblSoftRel.Text = m_QNphrase.lblRelease;
			lblStatus.Text = m_QNphrase.lblStatus;
			lblTCsAssgn.Text = m_QNphrase.lblTCsAssgn;
			lblTCsAssgnPc.Text = m_QNphrase.lblTCsAssgn + pcStr;
			lblTCsNotAssgn.Text = m_QNphrase.lblTCsNotAssgn;
			lblTime.Text = m_QNphrase.lblTime;
			lblTitle.Text = m_QNphrase.lblTitle;
			lblTotBad.Text = m_QNphrase.lblFailTCs;
			lblTotBadPc.Text = m_QNphrase.lblFailTCs + pcStr;
			lblTotDur.Text = m_QNphrase.lblTotDur;
			lblTotEx.Text = m_QNphrase.lblTotEx;
			lblTotExTime.Text = m_QNphrase.lblTotExTime;
			lblTotExPc.Text = m_QNphrase.lblTotEx + pcStr;
			lblTotNotEx.Text = m_QNphrase.lblNotEx;
			lblTotRemDur.Text = m_QNphrase.lblRemExDur;
			lblTotRemDurPc.Text = m_QNphrase.lblRemExDur + pcStr;
			lblTotTCs.Text = m_QNphrase.lblTotTCs;

			lstvTC.Columns[3].Text = m_QNphrase.lblTitle;
			lstvTC.Columns[4].Text = m_QNphrase.lblDuration;
			lstvTC.Columns[5].Text = m_QNphrase.lblAssgnd;
			lstvTC.Columns[6].Text = m_QNphrase.lblXTime;
			
			menuAbout.Text = m_QNphrase.mlblAbout;
			menuFile.Text = m_QNphrase.mlblFile;
			menuDel.Text = m_QNphrase.mlblDel;
			menuDocu.Text = m_QNphrase.mlblDocu;
			menuExit.Text = m_QNphrase.mlblExit;
			menuHelp.Text = m_QNphrase.mlblHelp;
			menuNew.Text = m_QNphrase.mlblNew;
			menuOpen.Text = m_QNphrase.mlblOpen;
			menuPrint.Text = m_QNphrase.mlblPrint;
			menuRefLst.Text = m_QNphrase.mlblRefLst;
			menuSave.Text = m_QNphrase.mlblSave;
			menuSaveNew.Text = m_QNphrase.mlblSaveAsNew;
			menuUID2Clip.Text = m_QNphrase.mlblUID2Clip;

			tabControl1.TabPages[0].Text = m_QNphrase.lblTCLst;
			tabControl1.TabPages[1].Text = m_QNphrase.lblStatistics;
		}

		#endregion

		#region Event Handling

		// --------------------------
		private void frmCmpgnMgr_Resize(object sender, System.EventArgs e) {
		
			int x, y;

			y = this.Height;
			x = this.Width;

			tabControl1.Height = y - m_tabc1DH;
			tabControl1.Width = x - m_tabc1DW;

			lstvTC.Height = y - m_lstTCSDH;
			lstvTC.Width = x - m_lstTCSDW;
			lstvTC.Columns[3].Width = x - m_colDW;

			txtStat.Top = y - m_txtStatDT;
			comboLog.Top = y - m_comboLogDT;
		}

		// --------------------------
		private void txtDesc_DoubleClick(object sender, System.EventArgs e) {
		
			handleTxtPop( sender, lblDesc.Text );
		}

		// --------------------------
		private void ctxtTCSLstAdd_Click(object sender, System.EventArgs e) {

			try {

				DatLstEntry entry;

				DataLst RsltLst;

				int i, x;
	
				setAppStat( AppStat.Proc );

				frmTCSel dialTCSel = new frmTCSel( m_xDB, false, m_Presets, m_TCSSelPresets, "tcs" );

				DialogResult dRes = dialTCSel.ShowDialog();

				if( DialogResult.Cancel == dRes ) {

					setAppStat( AppStat.OK );
				}
				else {

					RsltLst = dialTCSel.m_RsltLst;

					x = RsltLst.Count;

					if( x > 0 ) {

						for( i = 0; i < x; i++ ) {

							entry = RsltLst[i];
							
							addTCStoLst( ref entry );
						}

						updateStats();
					}
				}

				dialTCSel.Dispose();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}
		}

		// --------------------------
		private void ctxtTCSLstRem_Click(object sender, System.EventArgs e) {
		
			// stops if list changes from TC sets to TCs or back

			int i, j, x, y, ix, cix, iix, liix, pix;
			int lvl;

			ListViewItem lstVItem;
			TCLstTag tag;

			try {

				//chk = 0;

				cix = -1;

				setAppStat( AppStat.Proc );

				x = lstvTC.SelectedItems.Count;

				// Check the valid list (stops where the type switches)

				liix = lstvTC.SelectedItems[0].ImageIndex;

				for( i = 1;  i < x; ++i ) {

					lstVItem = lstvTC.SelectedItems[i];

/*
					tag = (TCLstTag)lstVItem.Tag;

					if( tag.m_isTCSet ) {

						if( chk == 1 ) {

							x = i;
						}
						else {

							chk = -1;
						}
					}
					else {

						if( chk == -1 ) {

							x = i;
						}
						else {
					
							chk = 1;
						}
					}								
*/					

					iix = lstVItem.ImageIndex;

					if( liix != iix ) {

						x = i;
					}
				}

				x--;

				// Delete in reverse order (avoids re-indexing)
				for( i = x; i > -1; --i ) {

					lstVItem = lstvTC.SelectedItems[i];

					tag = (TCLstTag)lstVItem.Tag;

					if( tag.m_isTCSet ) {

						ix = lstVItem.Index;

						//if( lstVItem.SubItems[1].Text == QNDefs.lstOperCollapse ) {
						iix = lstVItem.ImageIndex;

						if( (iix == 1) || (iix == 4) ) {
							
							collapseVEntry( lstVItem.Index );
						}

						delTCSLstEntry( tag );
						
						updParentTCSentries( ix, tag );
						
						lstVItem.Remove();

						lvl = tag.m_Lvl;
						
						// update the indexes
						y = lstvTC.Items.Count;

						for( j = 0; j < y; ++j ) {

							tag = (TCLstTag)lstvTC.Items[j].Tag;

/////????? does it work????
							if( (lvl == tag.m_Lvl) && (tag.m_Idx[lvl] > ix)  ) {

								tag.m_Idx[lvl]--;
							}
						}
					}
					else {

						ix = lstVItem.Index;
						pix = getParentTCSetIdx(ix);
						delTCLstEntry( ix, tag );
						updTCSentries( pix, tag );
						lstVItem.Remove();
						cix = pix;						
					}								
				}


				if( cix > -1 ) {

					// trick; this way we do not have to update the indexes of the
					// succeding TCs.
					collapseVEntry( cix );
					expandVEntry( cix );
				}

				updateStats();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
	
				handleExcp( excp );
			}
		}

		// --------------------------
		private void ctxtTCSLstView_Click(object sender, System.EventArgs e) {
		
			try {

				string appl;
				string UID;
				TCLstTag tag;
				TCLstEntry tcLstEnt;
				TCSLstEntry tcsLstEnt;

				setAppStat( AppStat.Proc );

				tag = (TCLstTag)lstvTC.SelectedItems[0].Tag;

				//ix = tag.m_Idx[0];
				//tcsLstEnt = (TCSLstEntry)m_TCSetLst[ix];

				if( tag.m_isTCSet ) {

					appl = QNDefs.exeTCSEdit;

					tcsLstEnt = getTCSEntryByLstTag( tag );

					UID = tcsLstEnt.m_RefUID;
				}
				else {

					appl = QNDefs.exeTCEdit;

					//ix = tag.m_Idx[1];
					//TCLstEnt = (TCLstEntry)tcsLstEnt.m_TCLst[ix];

					tcLstEnt = getTCEntryByLstTag( tag );

					UID = tcLstEnt.m_RefUID;
				}
					
				System.Diagnostics.Process proc = new System.Diagnostics.Process();

				proc.EnableRaisingEvents = false;

				proc.StartInfo.FileName = appl;

				proc.StartInfo.Arguments = UID;
				proc.Start();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
	
				handleExcp( excp );
			}
		}
				
		// --------------------------
		private void lstvTC_DoubleClick(object sender, System.EventArgs e) {

			int idx, iix;

			try {

				setAppStat( AppStat.Proc );

				idx = lstvTC.SelectedIndices[0];
				iix = lstvTC.Items[idx].ImageIndex;

				//if( lstvTC.Items[idx].SubItems[1].Text == QNDefs.lstOperExpand ) {
				if( (iix == 0) || (iix == 3) ) {

					expandVEntry( idx );
				}
				else {

					//if( lstvTC.Items[idx].SubItems[1].Text == QNDefs.lstOperCollapse ) {
					if( (iix == 1) || (iix == 4) ) {

						collapseVEntry( idx );
					}
				}

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
				
				handleExcp( excp );
			}	
		}

		// -----------------------
		private void menuSave_Click(object sender, System.EventArgs e) {
		
			try {

				RsltString UID;

				setAppStat( AppStat.Proc );
				
				UID = saveCmpgn();

				if( UID.isOK() ) {

					Rslt res = loadCmpgn( UID.theString );

					if( res.notOK() ) {

						handleErr( res, m_QNphrase.errCmpgnLoadFailed );
					}
					else {

						addLog( String.Format( m_QNphrase.msgSaved, txtTitle.Text ) );
					
						setAppStat( AppStat.OK );
					}
				}
			}
			catch( Exception excp ) {
				
				handleExcp( excp );
			}  
		}

		// -------------------
		private void menuDocu_Click(object sender, System.EventArgs e) {
		
			try {

				setAppStat( AppStat.Proc );

				System.Diagnostics.Process proc = new System.Diagnostics.Process();

				proc.EnableRaisingEvents = false;

				proc.StartInfo.FileName = QNDefs.manQN;

				proc.Start();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
	
				handleExcp( excp );
			}
		}

		// --------------------------------
		private void menuOpen_Click(object sender, System.EventArgs e) {
		
			try {

				DataLst RsltLst;

				int x;
				DatLstEntry entry;
			
				setAppStat( AppStat.Proc );

				frmCmpSel dialCmpSel = new frmCmpSel( m_xDB, true, m_Presets, m_Presets.m_CmpgnStatLst, m_CmpSelPresets );

				DialogResult dRes = dialCmpSel.ShowDialog();

				if( DialogResult.Cancel == dRes ) {

					setAppStat( AppStat.OK );
				}
				else {

					RsltLst = dialCmpSel.m_RsltLst;

					x = RsltLst.Count;

					if( x < 1 ) {

						setAppStat( AppStat.OK );
					}
					else {

						entry = RsltLst[0];

						loadCmpgn( entry.val );
					}
				}

				dialCmpSel.Dispose();
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}
		}

		// ----------------------
		private void ctxtMenuTCSLst_Popup(object sender, System.EventArgs e) {
		
			int x;

			string txt;

			TCLstTag tag;

			if( !m_IsClosed ) {

				setAppStat( AppStat.Proc );

				x = lstvTC.SelectedItems.Count;

				ctxtTCSLstView.Visible = false;
				ctxtTCSLstViewExec.Visible = false;

				ctxtTCSLstSep2.Visible = false;

				if( x < 1 ) {

					ctxtTCSLstAssgn.Visible = false;
					ctxtTCSLstClear.Visible = false;
					ctxtTCSLstRem.Visible = false;
					ctxtTCSLstSep1.Visible = false;
				}
				else {

					ctxtTCSLstSep1.Visible = true;

					if( m_IsOpen ) {

						ctxtTCSLstRem.Visible = true;
					}
					else {

						ctxtTCSLstRem.Visible = false;
					}

					ctxtTCSLstAssgn.Visible = true;

					txt = lstvTC.SelectedItems[0].SubItems[5].Text;

					if( txt.Length > 0 ) {

						// is assigned
						ctxtTCSLstClear.Visible = true;
					}
					else {

						ctxtTCSLstClear.Visible = false;
					}

					if( x == 1 ) {

						ctxtTCSLstSep2.Visible = true;

						ctxtTCSLstView.Visible = true;

						tag = (TCLstTag)lstvTC.SelectedItems[0].Tag;

						txt = lstvTC.SelectedItems[0].SubItems[6].Text;

						if( (!tag.m_isTCSet) && ( txt.Length > 0 ) ) {

							// was executed
							ctxtTCSLstViewExec.Visible = true;
						}
					}
				}

				setAppStat( AppStat.OK );
			}
		}

		// --------------------
		private void ctxtTCSLstAssgn_Click(object sender, System.EventArgs e) {
		
			try {

				int i, x;

				string[] roles;

				ListViewItem lstVItem;

				string user;

				setAppStat( AppStat.Proc );

				roles = new string[1];

				roles[0] = QNDefs.roleTest;

				frmUserSel dialUSel = new frmUserSel( m_xDB.m_DB, m_Presets, roles );

				DialogResult dRes = dialUSel.ShowDialog();

				if( DialogResult.Cancel != dRes ) {

					user = dialUSel.m_User;

					dialUSel.Dispose();			
		
					x = lstvTC.SelectedItems.Count;

					for( i = 0; i < x; ++i ) {

						lstVItem = lstvTC.SelectedItems[i];

						assignEntry( ref lstVItem, ref user );

						x = lstvTC.SelectedItems.Count;
					}
				}

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}			
		}

		// ------------------
		private void ctxtTCSLstClear_Click(object sender, System.EventArgs e) {
			
			int i, x;
			ListViewItem lstVItem;
			string blank = "";

			try {

				setAppStat( AppStat.Proc );

				x = lstvTC.SelectedItems.Count;

				for( i = 0; i < x; ++i ) {

					lstVItem = lstvTC.SelectedItems[i];

					assignEntry( ref lstVItem, ref blank );

					x = lstvTC.SelectedItems.Count;
				}

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
		
				handleExcp( excp );
			}
		}


		// -------------------
		private void menuNew_Click(object sender, System.EventArgs e) {
		
			setAppStat( AppStat.Proc );

			reset();

			setAppStat( AppStat.OK );
		}

		// ----------------
		private void menuAbout_Click(object sender, System.EventArgs e) {
							
			string title;
			string msg;

			setAppStat( AppStat.Proc );

			title = String.Format( m_QNphrase.msgAbout, m_QNphrase.lblTCExer );

			msg = m_QNTools.getAboutInfoBlock();
			
			MessageBox.Show( msg, title, MessageBoxButtons.OK );

			setAppStat( AppStat.OK );
		}

		// ------------------
		private void menuSaveNew_Click(object sender, System.EventArgs e) {
					
			try {

				RsltString UID;

				setAppStat( AppStat.Proc );

				reset4Clone();

				UID = saveCmpgn();

				if( UID.isOK() ) {

					Rslt res = loadCmpgn( UID.theString );

					if( res.notOK() ) {

						handleErr( res, m_QNphrase.errTCLoadFailed );
					}
					else {

						addLog( String.Format( m_QNphrase.msgSaved, txtTitle.Text ) );
					
						setAppStat( AppStat.OK );
					}
				}
			}
			catch( Exception excp ) {
						
				handleExcp( excp );
			}
		}

		// -------------------------
		private void menuDel_Click(object sender, System.EventArgs e) {
		
			DialogResult dRes;

			try {

				setAppStat( AppStat.Proc );

				string msg = String.Format( m_QNphrase.msgSure2dDel, txtTitle.Text );
			
				dRes = MessageBox.Show( msg, m_QNphrase.lblDeleting, MessageBoxButtons.YesNo, MessageBoxIcon.Question );

				if( DialogResult.Yes != dRes ) {

					setAppStat( AppStat.OK );
				}
				else {

					m_xDB.deleteXML( ref m_uidCmpgn );

					if( m_xDB.notOK() ) {

						msg = String.Format( m_QNphrase.errDelFailed, txtTitle.Text );

						handleErr( m_xDB, msg );

						m_xDB.resetRslt();
					}
					else {

						addLog( String.Format( m_QNphrase.msgDeleted, txtTitle.Text ) );

						reset();

						setAppStat( AppStat.OK );
					}
				}
			}
			catch( Exception excp ) {
						
				handleExcp( excp );
			}
		}

		// --------------------
		private void menuExit_Click(object sender, System.EventArgs e) {
							
			setAppStat( AppStat.Proc );

			Close();
		}

		// ---------------------
		private void ctxtLogEntry_Click(object sender, System.EventArgs e) {

			string msg;

			setAppStat( AppStat.Proc );

			msg = m_QNTools.getComboSelVal( ref comboLog );

			MessageBox.Show( msg, m_QNphrase.lblLogEntry, MessageBoxButtons.OK );	

			setAppStat( AppStat.OK );
		}

		// ---------------------
		private void ctxtTCSLstViewExec_Click(object sender, System.EventArgs e) {

			try {

				int x;

				RsltString UID = new RsltString();

				string appl;
				
				TCExLstEntry TCExEnt;
				TCLstTag tag;
				TCLstEntry tcLstEnt;

				setAppStat( AppStat.Proc );

				tag = (TCLstTag)lstvTC.SelectedItems[0].Tag;

				if( tag.m_isTCSet ) {

					//MessageBox.Show( msg, m_QNphrase.lblLogEntry, MessageBoxButtons.OK );	

					setAppStat( AppStat.OK );
				}
				else {

					//ix = tag.m_Idx[0];
					//tcsLstEnt = (TCSLstEntry)m_TCSetLst[ix];
					//tcsLstEnt = getTCSEntryByLstTag( tag );

					appl = QNDefs.exeTCExer;

					//ix = tag.m_Idx[1];
					//TCLstEnt = (TCLstEntry)tcsLstEnt.m_TCLst[ix];

					tcLstEnt = getTCEntryByLstTag( tag );

					x = tcLstEnt.m_TCExLst.Count;

					if( x < 2 ) {

						TCExEnt = (TCExLstEntry)tcLstEnt.m_TCExLst[0];
						UID.theString = TCExEnt.m_RefUID;
					}
					else {

						UID = runTCExDial( ref tcLstEnt.m_TCExLst );
					}

					if( UID.isOK() ) {

						setAppStat( AppStat.Proc );
					
						System.Diagnostics.Process proc = new System.Diagnostics.Process();

						proc.EnableRaisingEvents = false;

						proc.StartInfo.FileName = appl;

						proc.StartInfo.Arguments = UID;

						proc.Start();

						setAppStat( AppStat.OK );
					}
				}
			}
			catch( Exception excp ) {
	
				handleExcp( excp );
			}
		}

		// -------------------
		private void menuRefLst_Click(object sender, System.EventArgs e) {
		
			XmlNodeList tcsNodeLst;

			XMLDBNode tcsListNode;

			setAppStat( AppStat.Proc );

			resetTCLst();

			tcsListNode = m_xDB.getXMLsubTree( ref m_uidTCSLst );

			tcsNodeLst = tcsListNode.m_xNode.SelectNodes( "./CmpgnTCSet" );

			loadCTCSetLst( tcsNodeLst, m_TCSetLst );

			fillTCLst();

			updateStats();

			setAppStat( AppStat.OK );
		}

		// -------------------
		private void menuPrint_Click(object sender, System.EventArgs e) {
		
			string title;

			Rslt res = new Rslt( true );

			setAppStat( AppStat.Proc );

			RsltXMLNode xNode = bldCmpgnDoc();

			string xsltName = QNDefs.xlsCmpgnDoc + "_" + m_QNphrase.m_Loc + ".xsl";

			if( res.checkRslt( xNode ) ) {

				title = m_QNphrase.lblCampaign + " '" + txtTitle.Text + "'";

				res = m_GUIservice.printXDoc( xNode.m_xDoc, ref xsltName, ref title );
			}

			if( res.notOK() ) {

				handleErr( res, m_Presets.m_QNphrase.errPrintFailed );
			}
			else {

				setAppStat( AppStat.OK );
			}
		}

		//---------------------------
		private void menuUID2Clip_Click(object sender, System.EventArgs e) {
		
			Clipboard.SetDataObject( m_uidCmpgn );
		}

		#endregion
 	}

	// -------------------------------------
	internal class TCSInfo {

		public bool m_isErr;
		public bool m_isAllEx;

		public TCSInfo() {

			m_isErr = false;

			m_isAllEx = true;
		}
	}


}
