<?xml version='1.0'?>
<!-- Stylesheet for a problem report -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>

	<title>
		<xsl:text disable-output-escaping="yes">QA Navigator - Problemmeldung '</xsl:text>
		<xsl:value-of disable-output-escaping="yes" select="ProbReport/@Title"/>
		<xsl:text disable-output-escaping="yes">'</xsl:text>
	</title>

	<style>

	table { 
		background-color: #FFFFFF;
		empty-cells:show; 
		margin: 4px;
		border:3px grey;
		border-style: ridge;
		border-collapse: collapse 
	}

	td { 
		border:1px black;
		padding: 4px;
		border-style: solid;
		vertical-align: middle;
	}
	</style>

<script type="text/javascript" src="incl/SevClsCalc.js"></script>

<script type="text/javascript">
<xsl:comment>
// dummy: required! Do not remove!
</xsl:comment>
</script>

	<link rel="stylesheet" type="text/css" href="QNStyle.css"/>

		<xsl:apply-templates select="ProbReport/Script"/>
	</head>
	<body class="work">
		<xsl:apply-templates select="ProbReport"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProbReport">

	<h2 style="margin-left=6px;">Problemmeldung</h2>

	<table width="95%">
		<tr>
			<td width="120px"><b>Titel</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Title" /></td>
		</tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>Autor</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Author" /></td>
		</tr>
		<tr>
			<td width="120px"><b>Datum</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>
	</table>

	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<table>
		<tr><td width="120px"><b>Problem Status</b></td><td>
			<xsl:apply-templates select="./@ProbStat"/>
		</td></tr>
		<tr><td width="120px"><b>Zugeordnet</b></td><td>
			<xsl:apply-templates select="./@Assignd"/>
		</td></tr>
	</table>

	<table width="95%">
		<tr><td width="120px"><b>Anwendung</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td><td width="80px"><b>Release</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@SoftRel" /></td></tr>
		<tr><td width="120px"><b>Funktion</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td></tr>
	</table>

	<table>
		<tr><td width="140px"><b>Zustand der Anwendung</b></td><td>
	<xsl:call-template name="ApplStat"/>
		</td></tr>

		<tr><td width="140px"><b>Problemklasse</b></td><td>
	<xsl:call-template name="ProbCode"/>
		</td></tr>

		<tr><td width="140px"><b>Zustand der Daten</b></td><td>
	<xsl:call-template name="DataStat"/>
		</td></tr>

		<tr><td width="140px"><b>Reproduzierbar</b></td><td>
	<xsl:call-template name="Repro"/>
		</td></tr>

		<tr><td width="140px"><b>Fehlermeldung ausgegeben</b></td><td>
	<xsl:call-template name="ErrMsg"/>
		</td></tr>

		<tr><td width="140px"><b>umgehbar</b></td><td>
	<xsl:call-template name="WorkA"/>
		</td></tr>

		<tr><td width="140px"><b>Problemklasse</b></td><td>
			<script type="text/javascript">
			<xsl:comment>
				document.writeln( calcSevCls( "<xsl:value-of select="./@ProbCode" />" ) );
			</xsl:comment>
			</script>
		</td></tr>
	</table>

	<xsl:apply-templates select="./RefTCEx"/>

	<xsl:apply-templates select="./SysConfigRef"/>

	<table width="95%">
		<tr><td><b>Was wurde durchgef&uuml;hrt?</b></td></tr>
		<tr><td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./WDYD" /></td></tr>

		<tr><td><b>Was wurde erwartet?</b></td></tr>
		<tr><td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./Expctd" /></td></tr>

		<tr><td><b>Was wurde beobachtet?</b></td></tr>
		<tr><td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./Observ" /></td></tr>
	</table>

	<xsl:if test="FileUpload">

		<table border="2" cellspacing="0" cellpadding="4" width="95%">
			<tr>
				<td valign="center" align="left" colspan="2">

					<p>Zus&auml;tzliche Daten</p>
				</td>
			</tr>
			<xsl:apply-templates select="./FileUpload"/>
		</table>
	</xsl:if>
	
	<xsl:apply-templates select="./RefFix"/>

	<xsl:if test="LogEntry">

		<h4 style="margin-left=6px;">Log Eintr&auml;ge</h4>
		<xsl:apply-templates select="./LogEntry"/>
	</xsl:if>

	<xsl:if test="ProcLog">

		<h4 style="margin-left=6px;">Prozess-Logbuch</h4>
		<xsl:apply-templates select="./ProcLog"/>
	</xsl:if>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@ProbStat">

	<xsl:choose > 
		<xsl:when test = ". = 'sb'" > 
			<xsl:text>Gesendet</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'as'" > 
			<xsl:text>Zugeordnet</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'cr'" > 
			<xsl:text>Kommentar erbeten</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'rg'" > 
			<xsl:text>Beantwortet</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ev'" > 
			<xsl:text>In Untersuchung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'es'" > 
			<xsl:text>In Sch&auml;tzung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'nr'" > 
			<xsl:text>Nicht nachvollziehbar</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'dr'" > 
			<xsl:text>Entwurf</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'du'" > 
			<xsl:text>Doppelt</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'rCfNR'" > 
			<xsl:text>Antrag f&uuml;r CfNR</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'CfNR'" > 
			<xsl:text>Candidate for Next Release</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fx'" > 
			<xsl:text>In Bearbeitung</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'wf'" > 
			<xsl:text>Auf andere L&ouml;sung wartend</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ct'" > 
			<xsl:text>Klient Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'qt'" > 
			<xsl:text>Bereit f&uuml;r Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'at'" > 
			<xsl:text>Zum Testen zugeordnet</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ts'" > 
			<xsl:text>Im Test</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'tf'" > 
			<xsl:text>Test gescheitert</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'qr'" > 
			<xsl:text>Bereit f&uuml;r Review</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rv'" > 
			<xsl:text>In Pr&uuml;fung</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'bt'" > 
			<xsl:text>In Bau</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'sh'" > 
			<xsl:text>In Lieferung</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'cl'" > 
			<xsl:text>Abgeschlossen</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 're'" > 
			<xsl:text>Wiederer&ouml;ffnet</xsl:text> 
		</xsl:when> 
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ApplStat">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,1,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'C'" > 
			<xsl:text>F&auml;hrt fort</xsl:text>
		</xsl:when> 
		<xsl:when test = "$subCode = 'I'" > 
			<xsl:text>Unzug&auml;nglich</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'S'" > 
			<xsl:text>Angehalten</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'R'" >
			<xsl:text>Durcheinander</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'T'" >
			<xsl:text>H&auml;ngt</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'X'" >
			<xsl:text>Absturz</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="Repro">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,4,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'R'" > 
			<xsl:text>Ja</xsl:text> 
		</xsl:when> 
		<xsl:when test = "$subCode = 'X'" > 
			<xsl:text>Nein</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ProbCode">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,2,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'I'" > 
			<xsl:text>Ignorierbar</xsl:text>
		</xsl:when> 
		<xsl:when test = "$subCode = 'A'" > 
			<xsl:text>St&ouml;rend</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'O'" > 
			<xsl:text>Behindernd</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'B'" > 
			<xsl:text>Blockiert</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="DataStat">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,3,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'M'" > 
			<xsl:text>Minderer Datenverlust</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'L'" > 
			<xsl:text>Erheblicher Datenverlust</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'N'" > 
			<xsl:text>Kein Verlust</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ErrMsg">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,5,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'E'" > 
			<xsl:text>Ja</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'n'" > 
			<xsl:text>Nein</xsl:text>
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="WorkA">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,6,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'W'" > 
			<xsl:text>Ja</xsl:text>
<script type="text/javascript"><xsl:comment>
g_WA = true;
</xsl:comment></script>
		</xsl:when>
		<xsl:when test = "$subCode = 'n'" > 
			<xsl:text>Nein</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="RefTCEx">

	<table width="95%">
		<tr>
			<td width="140px"><b>Testfall Ausf&uuml;hrung</b></td>
		</tr>
		<tr><td>
			<xsl:if test="string(./@RefUID)">
				<xsl:text disable-output-escaping="yes">&lt;a href=&quot;VQANavDoc?QNA=ViewTCEx&amp;UID=</xsl:text>
				<xsl:value-of select="./@RefUID"/>
				<xsl:text disable-output-escaping="yes">&quot; target=&quot;_blank&quot;&gt;</xsl:text>
			</xsl:if>
			<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
			<xsl:if test="string(./@RefUID)">
				<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
			</xsl:if>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="SysConfigRef">

	<table width="95%">
		<tr>
			<td width="140px"><b>Systemkonfiguration</b></td>
		</tr>
		<tr>
			<td><p><xsl:value-of disable-output-escaping="yes" select="."/></p></td>
		</tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="RefFix">

	<table width="95%">
		<tr>
			<td width="140px"><b>L&ouml;sung</b></td>
		</tr>
		<tr><td>
			<xsl:text disable-output-escaping="yes">&lt;a href=&quot;VQANavDoc?QNA=ViewFix&amp;UID=</xsl:text>
			<xsl:value-of select="./@RefUID"/>
			<xsl:text disable-output-escaping="yes">&quot; target=&quot;_blank&quot;&gt;</xsl:text>
			<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
			<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="LogEntry">

	<table width="95%">
		<tr><td><xsl:value-of disable-output-escaping="yes" select="./@Title"/></td></tr>
		<tr><td>Autor: <xsl:value-of disable-output-escaping="yes" select="./@Author"/> Datum: <xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

	<table width="95%">
		<tr><td>Datum: <xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td></tr>
		<tr><td>
			<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="FileUpload">


	<tr><td>
		<table border="1" cellspacing="0" cellpadding="4" width="100%">

			<tr>
				<td valign="center" align="left" width="550pt">
					<p>
						<xsl:text disable-output-escaping="yes">&lt;a href=&quot;Upload/</xsl:text>
						<xsl:value-of select="./@UID"/>
						<xsl:text disable-output-escaping="yes">&quot; type=&quot;</xsl:text>
						<xsl:value-of select="./@ContentType"/>
						<xsl:text disable-output-escaping="yes">&quot; target=&quot;_blank&quot; &gt;</xsl:text>
						<xsl:value-of select="./@Name"/>
						<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
					</p>
					<p>Beschreibung:</p>
					<xsl:text disable-output-escaping="yes">&lt;input type=&quot;text&quot; size=&quot;82&quot; value=&quot;</xsl:text>
					<xsl:value-of disable-output-escaping="yes" select="./Desc" />
					<xsl:text disable-output-escaping="yes">&quot; readonly/&gt;</xsl:text>
				</td>
			</tr>

		</table>
	</td></tr>
</xsl:template>

</xsl:stylesheet>
